angular.module('starter.controllers')
  .controller('countCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, $timeout, $location, LoginService, $state, loginPromise, teamDataPromise) {
    $scope.colorStatus = {
      color: '#FF4646'
    };

    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.nextSlide = function() {
        $ionicSlideBoxDelegate.next();
      }
      $scope.previousSlide = function() {
        $ionicSlideBoxDelegate.previous();
      }

      $('#mainmenuid').show();
      // alert($stateParams.teamname);
      $scope.$parent.$parent.inDetailpage = false;
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.teamname = $stateParams.teamname;
      $scope.teamname2 = ''; //$scope.$parent.$parent.resultData[$stateParams.teamname].teamname;

      if($stateParams.teamname === 'p0')
      {
        $scope.resultData.amoc = {
          'resolved': [],
          'ongoing': [],
          'history': [],
          'teamname': 'Perf',
          'order': 3
        };
      }

      if($stateParams.teamname === 'amoc')
      {
        $scope.resultData.p0 = {
          'resolved': [],
          'ongoing': [],
          'history': [],
          'teamname': 'P0',
          'order': 1
        };
      }
      if (window.localStorage['username'] != '' && window.localStorage['password'] != '' && window.localStorage['username'] != null && window.localStorage['password'] != null) {
        $scope.loginData.username = window.localStorage['username'];
        $scope.loginData.password = window.localStorage['password'];
      }
      var teamName = $stateParams.teamname;
      var current = true;
      $scope.errorCallback = false;
      $scope.messageStatus = '';
      var loginService = loginPromise.startService($scope.loginData.username, $scope.loginData.password);
      var teamDataService = teamDataPromise.startService(teamName, $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, current, $scope.appVersion);
      var foundActiveAlert = false;
      var foundP1 = false;
      var foundP2 = false;
      if (current && teamName == 'amoc') {
        $scope.amocCurrentP1Unresolved = false;
        $scope.amocCurrentP2Unresolved = false;
        $scope.amocCurrentP1Resolved = false;
        $scope.amocCurrentP2Resolved = false;
      }
      if (!current && teamName == 'amoc') {
        $scope.amocHistoryP1 = false;
        $scope.amocHistoryP2 = false;
      }
      // $scope.resultData[teamName] = {};
      loginService.then(function(success) {
        teamDataService.then(
          function(response) {
            var newAlertedResponse = {};
            foundActiveAlert = false;
            if (current && teamName == 'amoc') {
              $scope.amocCurrentP1Unresolved = false;
              $scope.amocCurrentP2Unresolved = false;
              $scope.amocCurrentP34Unresolved = false;
              $scope.amocCurrentP1Resolved = false;
              $scope.amocCurrentP2Resolved = false;
              $scope.amocCurrentP34Resolved = false;
            }
            if (!current && teamName == 'amoc') {
              $scope.amocHistoryP1 = false;
              $scope.amocHistoryP2 = false;
              $scope.amocHistoryP34 = false;
            }
            angular.forEach(response, function(data) { //reseting all the slide data
              angular.forEach(data.palerts, function(perfalert) {
                $scope.resultData[teamName][perfalert.displayPage.toLowerCase()] = [];
              });
            });

            angular.forEach($scope.resultData[teamName], function(array, key) {
              if (array.constructor === Array) {
                angular.forEach(response, function(application) {
                  var applicationAux = JSON.parse(JSON.stringify(application));
                  applicationAux.palerts = [];
                  var found = false;
                  angular.forEach(application.palerts, function(perfalert) {
                    if (perfalert.displayPage.toLowerCase() == key && !found) {
                      applicationAux.p1alertNumbers = 0;
                      applicationAux.p2alertNumbers = 0;
                      applicationAux.p34alertNumbers = 0;
                      applicationAux.alertNumbers = 0;
                      $scope.resultData[teamName][key].push(applicationAux);
                      found = true;
                    }
                  });
                });
              }
            });
            angular.forEach(response, function(application) {
              angular.forEach(application.palerts, function(perfalert) {
                angular.forEach($scope.resultData[teamName], function(array, key) {
                  if (array.constructor === Array && perfalert.displayPage.toLowerCase() == key) {
                    angular.forEach(array, function(applicationInJson) {
                      if (applicationInJson.name == perfalert.applicationName) {
                        if (perfalert.displayPage.toLowerCase() == 'ongoing') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocCurrentP1Unresolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocCurrentP2Unresolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocCurrentP34Unresolved = true;
                          }
                        }
                        if (perfalert.displayPage.toLowerCase() == 'resolved') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocCurrentP1Resolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocCurrentP2Resolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocCurrentP34Resolved = true;
                          }
                        }
                        if (perfalert.displayPage.toLowerCase() == 'history') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocHistoryP1 = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocHistoryP2 = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocHistoryP34 = true;
                          }
                        }
                        applicationInJson.colorStatus = {
                          background: '#FFF',
                          color: '#79B509',
                          border: '2px solid #79B509'
                        };
                        applicationInJson.colorStatusBox = {
                          background: '#FFF',
                          color: '#79B509'
                        };
                        if (perfalert.priority.toUpperCase() == 'P1') {
                          applicationInJson.p1alertNumbers += 1;
                        }
                        if (perfalert.priority.toUpperCase() == 'P2') {
                          applicationInJson.p2alertNumbers += 1;
                        }
                        if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                          applicationInJson.p34alertNumbers += 1;
                        }
                        if (perfalert.status.toUpperCase() != 'RESOLVED') {
                          if (perfalert.priority.toUpperCase() == 'P0') {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: '#FF4646',
                              border: '2px solid #FF4646'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: '#FF4646',
                            };
                          } else if (perfalert.priority.toUpperCase() == 'P1' && !foundP1) {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: '#FF4646',
                              border: '2px solid #FF4646'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: '#FF4646',
                            };
                            foundP1 = true;
                          } else {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: 'orange',
                              border: '2px solid orange'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: 'orange',
                            };
                          }
                          foundActiveAlert = true;
                        }
                        applicationInJson.alertNumbers += 1;
                        applicationInJson.palerts.push(perfalert);
                      }
                    });
                  }
                });
              });
            });
            $scope.$broadcast('scroll.refreshComplete');
          },
          function(error) {
            $scope.errorCallback = true;
            $scope.$broadcast('scroll.refreshComplete');
            window.localStorage['current_page'] = 'palert';
            if(teamName.toLowerCase() == 'p0'){
              window.localStorage['current_page'] = 'palert_p0';
            }
            $scope.doLogin();
            // $scope.messageStatus = "We Came across an issue, please refresh";
          }
        );
      }, function(error) {
        alert('Please sign in again');
        $scope.isAuthenticated = false;
        $scope.loginMessage = '';
        $scope.hideBox = true;
        LoginService.setIsAuthenticated($scope.isAuthenticated);
        $state.go('app.login');
      });

      //$scope.resultData = $scope.$parent.$parent.resultData;
      //$scope.messageStatus = $scope.$parent.$parent.messageStatus;
      if ($stateParams.teamname != 'ongoing') {
        $scope.$parent.$parent.currentTeamName = $scope.resultData[$stateParams.teamname].teamname + ' Alerts';
      } else {
        $scope.$parent.$parent.currentTeamName = $scope.resultData[$stateParams.teamname].teamname + '';
      }
      $scope.$parent.$parent.currentApplication = '';
    });
  });
