angular.module('starter.controllers')
  .controller('graphsMenuCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Business Metrics';
	  
	  $scope.groups = [{
      title: "Mobility",
	  icon: "ion-stats-bars",
      contents: [
        {
          line: "Activation & Upgrade Counts",
		  url: "#/app/graphs/mobility/0"
        },
		{
          line: "Activations & Upgrades Response Time",
		  url: "#/app/graphs/mobility/1"
        },
		{
          line: "Port In & Port Out",
		  url: "#/app/graphs/mobility/2"
        }
		]
	},
	 {
      title: "Uverse",
	  icon: "ion-arrow-graph-up-right",
      contents: [
        {
          line: "OMS Orders Trend",
		  url: "#/app/graphs/uverse/0"
        },
		{
          line: "OMS Orders per Sales Channel",
		  url: "#/app/graphs/uverse/1"
        },
		{
          line: "OMS Stuck Order",
		  url: "#/app/graphs/uverse/2"
        }
		]
    },
	{
      title: "Payments",
	  icon: "ion-arrow-graph-up-left",
      contents: [
        {
          line: "Payment Trx Counts",
		  url: "#/app/graphs/payments/0"
        },
		{
          line: "Citi Settlement",
		  url: "#/app/graphs/ctsettlement/0"
        }
		]
    },
	{
      title: "Connected Car",
	  icon: "ion-aperture",
      contents: [
        {
          line: "GM Activations",
		  url: "#/app/graphs/oem_activations/0"
        },
		{
          line: "Audi Activations",
		  url: "#/app/graphs/oem_activations/1"
        },
		{
          line: "Jaguar & Land Rover Activations",
		  url: "#/app/graphs/oem_activations/2"
        },
		{
          line: "BMW Activations",
		  url: "#/app/graphs/oem_activations/3"
        },
		{
          line: "Volvo Activations",
		  url: "#/app/graphs/oem_activations/4"
        },
		{
          line: "Porsche Activations",
		  url: "#/app/graphs/oem_activations/5"
        },
		{
          line: "Ford Activations",
		  url: "#/app/graphs/oem_activations/6"
        },
		{
          line: "Honda Activations",
		  url: "#/app/graphs/oem_activations/7"
        },
		{
          line: "SXM_CHRYSLER Activations",
		  url: "#/app/graphs/oem_activations/8"
        }
		]
    },
	{
      title: "BDS",
	  icon: "ion-map",
      contents: [
        {
          line: "Bill Views in LS BIBA Hourly and Per Minute",
		  url: "#/app/graphs/bds/0"
        },
		{
          line: "BDS CSR Adj. Count",
		  url: "#/app/graphs/bds/1"
        },
		{
          line: "BDS LS Bill View Trx By Server",
		  url: "#/app/graphs/bds/2"
        },
		{
          line: "BDS Ondemand Response Time by Server",
		  url: "#/app/graphs/bds/3"
        },
		{
          line: "BDS ICBS Average Response Time",
		  url: "#/app/graphs/bds/4"
        },
		{
          line: "BDS ICBS Average Response Hourly and Per Minute",
		  url: "#/app/graphs/bds/5"
        }
		]
    },
	{
      title: "AT&T Mexico",
	  icon: "ion-map",
      contents: [
        {
          line: "Completed Orders Hourly and Per Minute",
		  url: "#/app/graphs/mx_graphs/0"
        }
		]
    }
  ];
  
  /*
   * if given group is the selected group, deselect it
   * else, select the given group
   */
  $scope.toggleGroup = function(group) {
    if ($scope.isGroupShown(group)) {
      $scope.shownGroup = null;
    } else {
      $scope.shownGroup = group;
    }
  };
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup === group;
  };
  
    });
  })
  .controller('paymentsMenuCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Payments';
    });
  })
  .controller('attMxCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Att Mexico';
    });
  })

  .controller('wttMenuCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state,fetchWlmDataService,$ionicLoading) {
    $scope.$on('$ionicView.enter', function(e) {
	  $ionicLoading.show();
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'Work Load Metrics';


	   var wlmService = fetchWlmDataService.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);

	     wlmService.then(function(response) {

		var result = [];
		result = response.strResponse;
		console.log(result);

		var objects= result.replace(/[\[\]"]/g,'' );
		//var objects1= result.replace(/[\[\]",]/g,' ' );
	    console.log(objects);

		  var data1 = objects.split(',');
		  $scope.title1 = data1[0];
		  $scope.totalApp1 = parseInt(data1[1]);
		  $scope.redApp1 = parseInt(data1[2]);
		  if($scope.redApp1>0)
		  {
			  $scope.styles1="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles1="font-size:18px;color:black";
		  }

		  $scope.yellowApp1 = parseInt(data1[3]);




	  var data2 = objects.split(',');
      $scope.title2 = data2[4];
	  $scope.totalApp2 = parseInt(data2[5]);
	  $scope.redApp2 = parseInt(data2[6]);
	  if($scope.redApp2>0)
	  {
		  $scope.styles2="font-size:18px;color:red";
	  }

	  else
	  {
		  $scope.styles2="font-size:18px;color:black";
	  }

	  $scope.yellowApp2 = parseInt(data2[7]);


	  var data3 = objects.split(',');
      $scope.title3 = data3[8];
	  $scope.totalApp3 = parseInt(data3[9]);
	  $scope.redApp3 = parseInt(data3[10]);
	  if($scope.redApp3>0)
	  {
		  $scope.styles3="font-size:18px;color:red";
	  }

	  else
	  {
		  $scope.styles3="font-size:18px;color:black";
	  }

	  $scope.yellowApp3 = parseInt(data3[11]);

	    var data4 = objects.split(',');
		  $scope.title4 = data4[12];
		  $scope.totalApp4 = parseInt(data4[13]);
		  $scope.redApp4 = parseInt(data4[14]);
		  if($scope.redApp4>0)
		  {
			  $scope.styles4="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles4="font-size:18px;color:black";
		  }

		  $scope.yellowApp4 = parseInt(data4[15]);


		  var data5 = objects.split(',');
		  $scope.title5 = data5[16];
		  $scope.totalApp5 = parseInt(data5[17]);
		  $scope.redApp5 = parseInt(data5[18]);
		  if($scope.redApp5>0)
		  {
			  $scope.styles5="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles5="font-size:18px;color:black";
		  }

		  $scope.yellowApp5 = parseInt(data5[19]);


		  var data6 = objects.split(',');
		  $scope.title6 = data6[20];
		  $scope.totalApp6 = parseInt(data6[21]);
		  $scope.redApp6 = parseInt(data6[22]);
		  if($scope.redApp6>0)
		  {
			  $scope.styles6="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles6="font-size:18px;color:black";
		  }

		  $scope.yellowApp6 = parseInt(data6[23]);


		   var data7 = objects.split(',');
		//  $scope.title7 = data7[24];
		  $scope.title7 = "Reject";
		  $scope.totalApp7 = parseInt(data7[25]);
		  $scope.redApp7 = parseInt(data7[26]);
		  if($scope.redApp7>0)
		  {
			  $scope.styles7="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles7="font-size:18px;color:black";
		  }

		  $scope.yellowApp7 = parseInt(data7[27]);

		   var data8 = objects.split(',');
		  //$scope.title8 = data8[28];
		  $scope.title8 = "RFI";
		  $scope.totalApp8 = parseInt(data8[29]);
		  $scope.redApp8 = parseInt(data8[30]);
		  if($scope.redApp8>0)
		  {
			  $scope.styles8="font-size:18px;color:red";
		  }

		  else
		  {
			  $scope.styles8="font-size:18px;color:black";
		  }

		  $scope.yellowApp8 = parseInt(data8[31]);
		
		  $ionicLoading.hide();
	  });
		 	

	    });
    })


  .controller('davDashboardCtrl', function($scope, $stateParams, $http, $ionicHistory, $state) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'DAV Dashboard';
    });
  })
