angular.module('starter.controllers').controller(
		'impactMeterCtrl',
		function($scope, $stateParams, $http, $ionicHistory,
				impactMeterPromise, $state, $ionicSlideBoxDelegate) {
			
			$scope.refreshImpactMeter = function() {
      		$state.reload();
   		 }		
    
			

			$scope.$on('$ionicView.enter', function(e) {

				$scope.$parent.$parent.inDetailpage = false;
				$('#mainmenuid').show();
      	
      	
		      function doOnOrientationChange() {
		        switch (window.orientation) {
		          case -90:
		          case 90:
		            $scope.heightLandscape = {
		              height: '-webkit-fill-available',
		              width: 'unset'
		            };
		            $scope.enableOverflow = 'true';
		            $scope.adjustHeigt = {
		              'padding-top': '16%'
		            };
		            break;
		          default:
		            $scope.heightLandscape={};
		            break;
		        }
		      }
		      window.addEventListener('orientationchange', doOnOrientationChange);
		      if (ionic.Platform.isIOS()) {
		        $scope.styleSlider = {
		          "margin-top": 23+'px',
		          "margin-bottom": 50+'px'
		        };
		      }
      
				delete $scope.$parent.$parent.currentTeamName;
				$scope.$parent.$parent.currentTeamName = 'Impact View';

				var impactsMeterPromise = impactMeterPromise.startService(
						$scope.loginData.username, $scope.getTimeFormat(),
						$scope.myDeviceFullInfo, $scope.appVersion);

				 impactsMeterPromise.then(function(response) {
				if (response) {
					
				var totalCount = [];
				var linePriority = [];
				
				totalCount[0]=totalCount[1]=totalCount[2]=totalCount[3]=totalCount[4]=0;
				linePriority[0]=linePriority[1]=linePriority[2]=linePriority[3]=linePriority[4]='P5';
				

				if(response.openCountsPerLine){
				response.openCountsPerLine.forEach(function(data)
				{
  				switch(data.line){
  					case 'Mobility':
        			totalCount[0]=totalCount[0]+parseInt(data.openCount);
        			if(data.priority.charAt(1) < linePriority[0].charAt(1))
        				linePriority[0]=data.priority;
        			break;
		    		case 'Uverse':		    		
		        	totalCount[1]=totalCount[1]+parseInt(data.openCount);
        			if(data.priority.charAt(1) < linePriority[1].charAt(1))
        				linePriority[1]=data.priority;
		       	 break;
		       	 case 'Payments':
		        	totalCount[2]=totalCount[2]+parseInt(data.openCount);
        			if(data.priority.charAt(1) < linePriority[2].charAt(1))
        				linePriority[2]=data.priority;
		       	 break;
		       	 case 'EMAS':
		        	totalCount[3]=totalCount[3]+parseInt(data.openCount);
        			if(data.priority.charAt(1) < linePriority[3].charAt(1))
        				linePriority[3]=data.priority;
		       	 break;
		       	 case 'Enterprise':
		        	totalCount[4]=totalCount[4]+parseInt(data.openCount);
        			if(data.priority.charAt(1) < linePriority[4].charAt(1))
        				linePriority[4]=data.priority;
		       	 break;
		    		default:
		        	console.log("No Data");
		        	break;
  				}
				});
			}
				
				var range=[];
				
				var j=0;
				
				for(var i=0; i < linePriority.length ; i++){
					
					switch(linePriority[i])
					{
						case 'P1':
						range[j]=totalCount[i]*0.3;
						range[j+1]=totalCount[i]*0.6;
						range[j+2]=totalCount[i]*0.9;
						range[j+3]=totalCount[i]*1.2;
						break;
						case 'P2':
						range[j]=totalCount[i]*0.4;
						range[j+1]=totalCount[i]*0.8;
						range[j+2]=totalCount[i]*1.2;
						range[j+3]=totalCount[i]*1.6;
						break;
						case 'P3':
						case 'P4':
						range[j]=totalCount[i]*0.7;
						range[j+1]=totalCount[i]*1.4;
						range[j+2]=totalCount[i]*2.1;
						range[j+3]=totalCount[i]*2.8;
						break;
						default:
						range[j]=1;
						range[j+1]=2;
						range[j+2]=3;
						range[j+3]=4;
						break;
						
					}
					j=j+4;
				}

					
				$('#Mobility').highcharts({

					chart : {
						type : 'gauge',
						plotBackgroundColor : null,
						plotBackgroundImage : null,
						plotBorderWidth : 0,
						plotShadow : false,
						height : 200
					},

					title : {
						text : 'Mobility'
					},

					credits : {
						enabled : false
					},
					pane : {
						startAngle : -90,
						endAngle : 90,
						background : null
					},

					plotOptions : {
						gauge : {
							dataLabels : {
								enabled : true
							},
							dial : {
								baseLength : '0%',
								baseWidth : 20,
								radius : '100%',
								rearLength : '0%',
								topWidth : 1
							}
						}
					},

					// the value axis
					yAxis : {
						labels : {
							enabled : false,
							distance : 20
						},
						minorTickLength : 0,
						min : 0,
						max : range[3],
						plotBands : [ {
							from : 0,
							to : range[0],
							color : 'rgb(51, 153, 51)', // green
							thickness : '50%'
						}, {
							from :range[0],
							to : range[1],
							color : 'rgb(255, 209, 26)', // yellow
							thickness : '50%'
						},{
							from : range[1],
							to : range[2],
							color : 'rgb(255, 140, 26)', // orange
							thickness : '50%'
						}, {
							from : range[2],
							to : range[3],
							color : 'rgb(255, 0, 0)', // red
							thickness : '50%'
						} ]
					},

					series : [ {
						name : 'Count',
						data : [totalCount[0]] 
					} ]

				});

				$('#Uverse').highcharts({

					chart : {
						type : 'gauge',
						plotBackgroundColor : null,
						plotBackgroundImage : null,
						plotBorderWidth : 0,
						plotShadow : false,
						height : 200
					},

					title : {
						text : 'Uverse'
					},

					credits : {
						enabled : false
					},

					pane : {
						startAngle : -90,
						endAngle : 90,
						background : null
					},

					plotOptions : {
						gauge : {
							dataLabels : {
								enabled : true
							},
							dial : {
								baseLength : '0%',
								baseWidth : 20,
								radius : '100%',
								rearLength : '0%',
								topWidth : 1
							}
						}
					},

					// the value axis
					yAxis : {
						labels : {
							enabled : false,
							distance : 20
						},
						minorTickLength : 0,
						min : 0,
						max : range[7],
						plotBands : [ {
							from : 0,
							to : range[4],
							color : 'rgb(51, 153, 51)', // green
							thickness : '50%'
						}, {
							from : range[4],
							to : range[5],
							color : 'rgb(255, 209, 26)', // yellow
							thickness : '50%'
						}, {
							from : range[5],
							to : range[6],
							color : 'rgb(255, 140, 26)', // orange
							thickness : '50%'
						},{
							from : range[6],
							to : range[7],
							color : 'rgb(255, 0, 0)', // red
							thickness : '50%'
						} ]
					},

					series : [ {
						name : 'Count',
						data : [ totalCount[1] ]
					} ]

				});

				$('#Payments').highcharts({

					chart : {
						type : 'gauge',
						plotBackgroundColor : null,
						plotBackgroundImage : null,
						plotBorderWidth : 0,
						plotShadow : false,
						height : 200
					},

					title : {
						text : 'Payments'
					},

					credits : {
						enabled : false
					},

					pane : {
						startAngle : -90,
						endAngle : 90,
						background : null
					},

					plotOptions : {
						gauge : {
							dataLabels : {
								enabled : true
							},
							dial : {
								baseLength : '0%',
								baseWidth : 20,
								radius : '100%',
								rearLength : '0%',
								topWidth : 1
							}
						}
					},

					// the value axis
					yAxis : {
						labels : {
							enabled : false,
							distance : 20
						},
						minorTickLength : 0,
						min : 0,
						max : range[11],
						plotBands : [ {
							from : 0,
							to : range[8],
							color : 'rgb(51, 153, 51)', // green
							thickness : '50%'
						}, {
							from : range[8],
							to : range[9],
							color : 'rgb(255, 209, 26)', // yellow
							thickness : '50%'
						},{
							from : range[9],
							to : range[10],
							color : 'rgb(255, 140, 26)', // orange
							thickness : '50%'
						}, {
							from : range[10],
							to : range[11],
							color : 'rgb(255, 0, 0)', // red
							thickness : '50%'
						} ]
					},

					series : [ {
						name : 'Count',
						data : [ totalCount[2] ]
					} ]

				});

				$('#EMAS').highcharts({

					chart : {
						type : 'gauge',
						plotBackgroundColor : null,
						plotBackgroundImage : null,
						plotBorderWidth : 0,
						plotShadow : false,
						height : 200
					},

					title : {
						text : 'EMAS'
					},

					credits : {
						enabled : false
					},

					pane : {
						startAngle : -90,
						endAngle : 90,
						background : null
					},

					plotOptions : {
						gauge : {
							dataLabels : {
								enabled : true
							},
							dial : {
								baseLength : '0%',
								baseWidth : 20,
								radius : '100%',
								rearLength : '0%',
								topWidth : 1
							}
						}
					},

					// the value axis
					yAxis : {
						labels : {
							enabled : false,
							distance : 20
						},
						minorTickLength : 0,
						min : 0,
						max : range[15],
						plotBands : [ {
							from : 0,
							to : range[12],
							color : 'rgb(51, 153, 51)', // green
							thickness : '50%'
						}, {
							from : range[12],
							to : range[13],
							color : 'rgb(255, 209, 26)', // yellow
							thickness : '50%'
						}, {
							from : range[13],
							to : range[14],
							color : 'rgb(255, 140, 26)', // orange
							thickness : '50%'
						},{
							from : range[14],
							to : range[15],
							color : 'rgb(255, 0, 0)', // red
							thickness : '50%'
						} ]
					},

					series : [ {
						name : 'Count',
						data : [ totalCount[3] ]
					} ]

				});

				$('#Enterprise').highcharts({

					chart : {
						type : 'gauge',
						plotBackgroundColor : null,
						plotBackgroundImage : null,
						plotBorderWidth : 0,
						plotShadow : false,
						height : 200
					},

					title : {
						text : 'Enterprise'
					},

					credits : {
						enabled : false
					},

					pane : {
						startAngle : -90,
						endAngle : 90,
						background : null
					},

					plotOptions : {
						gauge : {
							dataLabels : {
								enabled : true
							},
							dial : {
								baseLength : '0%',
								baseWidth : 20,
								radius : '100%',
								rearLength : '0%',
								topWidth : 1
							}
						}
					},

					// the value axis
					yAxis : {
						labels : {
							enabled : false,
							distance : 20
						},
						minorTickLength : 0,
						min : 0,
						max : range[19],
						plotBands : [ {
							from : 0,
							to : range[16],
							color : 'rgb(51, 153, 51)', // green
							thickness : '50%'
						}, {
							from : range[16],
							to : range[17],
							color : 'rgb(255, 209, 26)', // yellow
							thickness : '50%'
						},{
							from : range[17],
							to : range[18],
							color : 'rgb(255, 140, 26)', // orange
							thickness : '50%'
						}, {
							from : range[18],
							to : range[19],
							color : 'rgb(255, 0, 0)', // red
							thickness : '50%'
						} ]
					},

					series : [ {
						name : 'Count',
						data : [ totalCount[4] ]
					} ]

				});
				} else {
					console.log('error');
				}
			});

		});
		
		});
