angular.module('starter.controllers')
  .controller('AppCtrl', function($scope, $rootScope, $ionicModal, $timeout, $location, LoginService, $state, $http, $stateParams, loginPromise, registrationPromise, aclPromise, teamDataPromise, QuickActionService, getAppUpdateService, countDataPromise, $interval) {

    // With the new view caching in Ionic, Controllers are only called
    // when they are recreated or on app start, instead of every page change.
    // To listen for when this page is active (for example, to refresh data),
    // listen for the $ionicView.enter event:
    //$scope.$on('$ionicView.enter', function(e) {
    //});

    // Form data for the login modal
    window.localStorage['current_page'] = '';
    $('#mainmenuid').show();
    $scope.loginData = {};
    $scope.defaultApplication = 'p0';
    $scope.loginData.username = '';
    $scope.loginData.password = '';
    $scope.hideMenu = true;
    $scope.resultData = {};
    $scope.resultDataHistory = {};
    $scope.loginMessage = '';
    $scope.isAuthenticated = false;
    $scope.hideBox = true;
    $scope.inDetailpage = false;
    $scope.shareOnAppPage = false;
    // $scope.deviceToken = '';
    $scope.dataPushNotification = {};
    $scope.currentTeam = '';
    $scope.currentInfo;
    $scope.currentAlerts = true;
    $scope.urlData = [];
    $scope.palertdata = {};
    $scope.palertsubject = "";
    $scope.summaryData = [];
    $scope.aclAccess = [];
    $scope.userRoles = [];
    //ADDING DYNAMIC P1 P2 ALERTS FOR amoc
    $scope.amocCurrentP1Unresolved = false;
    $scope.amocCurrentP2Unresolved = false;
    $scope.amocCurrentP34Unresolved = false;
    $scope.amocCurrentP1Resolved = false;
    $scope.amocCurrentP2Resolved = false;
    $scope.amocCurrentP34Resolved = false;
    $scope.amocHistoryP1 = false;
    $scope.amocHistoryP2 = false;
    $scope.amocHistoryP34 = false;
    $scope.appVersion = '1.3.0';
    //

    // Create the login modal that we will use later
    // $ionicModal.fromTemplateUrl('templates/login.html', {
    //   scope: $scope
    // }).then(function(modal) {
    //   $scope.modal = modal;
    // });
    // Triggered in the login modal to close it

    $scope.validateForm = function() {
      var response = true;
      var message = '';
      $scope.loginMessage = message;
      if ($scope.loginData.username.length != 6) {
        message += '<p>The Username must be 6 chars long</p>';
        response = false;
      }
      if ($scope.loginData.username.length == 0 || $scope.loginData.password.length == 0) {
        message += '<p>Please enter Username and Password</p>';
        response = false;
      }
      $scope.loginMessage = message;
      return response;
    };
    $scope.formatDate = function(datereived) {
      var monthNames = [
        "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
      ];
      var dateTime = datereived.split('T');
      var ymd = dateTime[0].split('-');
      var timeparsed = dateTime[1].split(' ');
      var hourmin = timeparsed[0].split(':');
      return ymd[2] + '-' + monthNames[parseInt(ymd[1]) - 1] + '-' + (parseInt(ymd[0]) - 2000) + ' ' + hourmin[0] + ':' + hourmin[1];
    };
    //Changes from harish
    $scope.getParams = function($deliveryType, $deviceToken, $appID) {
      return "?&deliveryType=" + $deliveryType + "&deviceToken=" + $deviceToken + "&appId=" + $appID;
    };

    //Changes from Sumit
    $scope.getDavParams = function($davUrl, $approvalFlag, $deployDate) {
      console.log("?&dav-url=" + $davUrl + "&approvalFlag=" + $approvalFlag + "&deployDate=" + $deployDate);
      return "?&dav-url=" + $davUrl + "&approvalFlag=" + $approvalFlag + "&deployDate=" + $deployDate;
    };


    $scope.getDeviceType = function() {
      var device = 'APN';
      if ($scope.myDeviceInfo() === "Android") {
        device = 'GCM';
      }
      return device;
    };
    //did we login function
    $scope.showDetail = function() {
      //NG HIDE FALSE = SHOW
      return !$scope.inDetailpage && !LoginService.isAuthenticated();
    };
    $scope.didWeLogin = function() {
      //NG HIDE FALSE = SHOW
      return !LoginService.isAuthenticated();
    };
    // Perform the login action when the user submits the login form
    $scope.loginIssue = true;
    $scope.responseLoginData;
    $scope.doLogin = function() {
      //CHECK IF WE HAVE DATA FILLED OUT
      $scope.hideBox = false;
      $scope.loginData.username = $scope.loginData.username.toLowerCase();
      if ($scope.validateForm()) {
        $scope.hideBox = true;
        $scope.isAuthenticated = false;
        var loginService = loginPromise.startService($scope.loginData.username, $scope.loginData.password);
        loginService.then(
          function(success) {
            $scope.isAuthenticated = true;
            LoginService.setIsAuthenticated($scope.isAuthenticated);
            //changes from harish
            // Check if 3D Touch is supported on the device
            //if (window.ThreeDeeTouch) {
            if (window.ThreeDeeTouch) {
              window.ThreeDeeTouch.isAvailable(function(available) {
                if (available) {
                  var countP0 = 0; // p0
                  var countP1 = 0; // perf
                  var alertCountACL = countDataPromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
                  alertCountACL.then(function(countArray) {
                    angular.forEach(countArray, function(count) {
                      if (count.priority.toLowerCase() == 'p1') {
                        countP1 += parseInt(count.openAlertsCount);
                      } else if (count.priority.toLowerCase() == 'p0') {
                        countP0 += parseInt(count.openAlertsCount);
                      }
                    });
                    var qucikAct = QuickActionService.configure(countP0, countP1);
                  }, function(errorMessage) {
                    alert(errorMessage)
                  });
                }
              });
            }
            //changes end
            window.localStorage['username'] = $scope.loginData.username.toLowerCase();
            window.localStorage['password'] = $scope.loginData.password;
            if ($scope.deviceToken !== 'undefined') {
				
				$scope.myDeviceFullInfo=$scope.myDeviceInfo()+'|'+ionic.Platform.device().model+'|'+$scope.myDeviceInfo()+ionic.Platform.version();
				
              var registrationService = registrationPromise.startService($scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.loginData.username, $scope.loginData.password, $scope.getDeviceType(), $scope.deviceToken, $scope.getParams($scope.getDeviceType(), $scope.deviceToken, "ApStat"), $scope.appVersion);

              registrationService.then(
                function(success) {},
                function(error) {}
              );
            }

            var aclService = aclPromise.startService($scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.loginData.username, $scope.appVersion);
            aclService.then(
              function(success) {
                $scope.urlData = [];
                //////////////////////////////////////////////////////
                var firstComponent;
                //console.log(success);
                $scope.aclAccess = success.userProfile.componentIds;
                if (!success.userProfile.componentIds) {
                  console.log('User is not assigned any roles in the application and therefore redirect tothe page having an access provisioning link');
                } else {
                  $scope.userRoles = success.userProfile.componentIds;
                  var imageMenu = success.userProfile.images;
                  var menuItems = success.userProfile.roles;

                  angular.forEach(menuItems, function(item) {
                    angular.forEach($scope.userRoles, function(roleid) {
                      if (roleid === item.roleId && item.roleId != 'palert_p0' && item.roleId != 'palert' && item.roleId != 'palert_attmx') {
                        /*if(item.roleId === 'palert_p0' || item.roleId === 'palert' || item.roleId === 'mex_perf_alerts') {
                            var team = item.team;
                            $scope.resultData.team = {
                                'resolved': [],
                                'ongoing': [],
                                'history': [],
                                'teamname': item.team,
                            };
                            if (firstComponent == undefined) {
                        firstComponent = item.roleId;
                      }
                           }*/
                        $scope.urlData.push({
                          'url': item.baseUrl,
                          'parameter': 'non-image',
                          'alias': item.menuText,
                          'level': parseInt(item.menuOrder),
                          'icon': item.icon
                        });
                      }
                    });
                  });
                  angular.forEach($scope.userRoles, function(componentId) {
                    //alert(componentId);
                    if (componentId === 'palert_p0') {
                      $scope.resultData.p0 = {
                        'resolved': [],
                        'ongoing': [],
                        'history': [],
                        'teamname': 'P0',
                        'order': 1
                      };
                      found = true;
                      $scope.urlData.push({
                        'url': '#/app/team/p0',
                        'parameter': 'p0',
                        'alias': 'P0 Alerts',
                        'level': 1,
                        'icon': 'ion ion-alert'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    if (componentId === 'palert') {
                      $scope.resultData.amoc = {
                        'resolved': [],
                        'ongoing': [],
                        'history': [],
                        'teamname': 'Perf',
                        'order': 3
                      };
                      $scope.urlData.push({
                        'url': '#/app/team2/amoc',
                        'parameter': 'amoc',
                        'alias': 'Perf Alerts',
                        'level': 1,
                        'icon': 'ion ion-alert-circled'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    if (componentId === 'palert_attmx') {
                      $scope.resultData.attmx = {
                        'resolved': [],
                        'ongoing': [],
                        'history': [],
                        'teamname': 'Mex Perf',
                        'order': 4
                      };
                      $scope.urlData.push({
                        'url': '#/app/team/attmx',
                        'parameter': 'attmx',
                        'alias': 'Mex Perf Alerts',
                        'level': 2,
                        'icon': 'ion ion-alert-circled'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    //Keep the below
                    /*if (componentId === 'home_screen') {
                      $scope.urlData.push({
                        'url': '#/app/summary/',
                        'parameter': 'summary',
                        'level': 0,
                        'alias': 'Home'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    if (componentId === 'uverse_system_overview') {
                      $scope.urlData.push({
                        'url': '#/app/systemOverview/',
                        'parameter': 'systemOverview',
                        'alias': 'System Overview',
                        'level': 14,
                        'icon': 'ion ion-information'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    if (componentId === 'uverse_oms_order_trend') {
                      $scope.urlData.push({
                        'url': '#/app/graphsMenu/',
                        'parameter': 'uverse_oms_order_trend',
                        'level': 8,
                        'alias': 'Business Metrics',
                        'icon': 'ion-help-buoy'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }
                    if (componentId === 'about_screen') {
                      $scope.urlData.push({
                        'url': '#/app/aboutMenu/',
                        'parameter': 'aboutMenu',
                        'alias': 'About',
                        'level': 15,
                        'icon': 'ion ion-information'
                      });
                      if (firstComponent == undefined) {
                        firstComponent = componentId;
                      }
                    }*/
                    //Done
                  });
                  angular.forEach(imageMenu, function(menuDetails) {
                    angular.forEach($scope.userRoles, function(roleid) {
                      if (roleid === menuDetails.roleId) {
                        $scope.urlData.push({
                          'url': '#/app/imagesmenu/' + menuDetails.pageHeading + '/' + menuDetails.roleId + '/' + menuDetails.serverPath,
                          'parameter': 'image',
                          'alias': menuDetails.menuText,
                          'level': parseInt(menuDetails.menuOrder),
                          'icon': menuDetails.icon
                        });
                      }
                    });
                  });
                  if (firstComponent == undefined) {
                    firstComponent = componentId;
                  }
                  //////////////////////////////////////////////////////
                }
                var appUpdateService = getAppUpdateService.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
                appUpdateService.then(
                  function(success) {
                    $scope.latestVersion = success.applicationUpdate.applicationVersion;
                    $scope.latestUpdates = success.applicationUpdate.releaseNotes;
                    $scope.downloadUrl = success.applicationUpdate.downloadUrl;
                    if ($scope.latestVersion !== undefined && $scope.appVersion !== $scope.latestVersion) {
                      $scope.urlData.push({
                        'url': '#/app/appUpdate/',
                        'parameter': 'app_update',
                        'icon': 'ion ion-arrow-down-c',
                        'alias': 'Updates Available'
                      });
                    }
                  },
                  function(error) {
                    alert("Got error while fetching the application updates.");
                  }
                );

                // event.preventDefault();
                if (Object.keys($scope.urlData).length > 0) {
                  angular.forEach($scope.urlData, function(data) {
                    // alert(JSON.stringify(data));
                    if (data.parameter === 'p0' ||
                      data.parameter === 'amoc' ||
                      data.parameter === 'attmx') {
                      $scope.getJsonAlerts(data.parameter, true);
                      // $scope.getJsonAlerts(data.parameter, false);
                    }
                  });
                  if (Object.keys($scope.perfNotification).length != 0) {
                    /*$scope.getJsonAlerts($scope.perfNotification.additionalData.team, true);
                    $state.go('app.notification');*/

                  } else {
                    //alert("Switching using firstComponent = " + firstComponent);
                    if (window.localStorage['current_page'].length > 0) {
                      firstComponent = window.localStorage['current_page'];
                    }
                    $scope.urlData.sort($scope.dynamicSort("level"));
                    //Landing page will be home always and access will be granted to all, hence skipping the case
                    $state.go('app.summary');
                    /*switch (firstComponent) {
                      case 'palert_p0':
                        $state.go('app.team', {
                          'teamname': 'p0'
                        });
                        break;
                      case 'palert':
                        $state.go('app.team2', {
                          'teamname': 'amoc'
                        });
                        break;
                      case 'iphone_reports_static':
                        $state.go('app.iphonereportsstatic');
                        break;
                      case 'psg_bulletin':
                        $state.go('app.psgbulletinstatic');
                        break;
                      case 'dtv_dashboard_static':
                        $state.go('app.dtvdash');
                        break;
                      case 'psg_friday_flash':
                        $state.go('app.dynamicdash');
                        break;
                      case 'uverse_oms_order_trend':
                        $state.go('app.graphs', {
                          'graphName': 'uverse_oms_order_trend'
                        });
                        break;
                      case 'home_screen':
                        $state.go('app.summary');
                        break;
                      case 'uverse_system_overview':
                        $state.go('app.systemOverview');
                        break;
                      case 'uverse_system_overview':
                        $state.go('app.systemOverview');
                        break;
                      case 'mgmt_reports':
                        $state.go('app.mgmtreports');
                        break;
                      default:
                        //This will happen if a role is not handled above
                        alert("We encountered an unknown role: " + firstComponent + ". Please report it to AMOC_TOOLS@LIST.ATT.COM via email");
                    }*/
                  }
                } else {
                  //alert('You do not have permission to access the application. Please email AMOC_TOOLS@LIST.ATT.COM for access');
                  $scope.isAuthenticated = false;
                  $scope.loginMessage = '';
                  $scope.hideBox = true;
                  LoginService.setIsAuthenticated($scope.isAuthenticated);
                  //$state.go('app.login');
                  $state.go('app.accessProvisioningModal');
                }
              },
              function(error) {}
            );
          },
          function(error) {
            alert("We're currently unable to log you in. Please try again after some time.");
            $scope.hideBox = false;
            LoginService.setIsAuthenticated($scope.isAuthenticated);
            $scope.loginMessage = error.data;
            $ionicLoading.hide();
            $scope.$broadcast('scroll.refreshComplete');
            window.localStorage['current_page'] = '';
            $scope.$parent.$parent.doLogin();
          }
        );
      }
    };
    $scope.myDeviceInfo = function() {
      var device = 'Android';
      if (ionic.Platform.isIOS()) {
        device = 'iOS';
      }
      if (ionic.Platform.isWindowsPhone()) {
        device = 'windows';
      }
      return device;
    };
    $scope.getTimeFormat = function() {
      var d = new Date();
      var monthNames = [
        "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
      ];
      var hours = d.getHours();
      var minutes = d.getMinutes();
      var ampm = hours >= 12 ? 'pm' : 'am';
      hours = hours % 12;
      hours = hours ? hours : 12; // the hour '0' should be '12'
      minutes = minutes < 10 ? '0' + minutes : minutes;
      return monthNames[d.getMonth()] + ' ' + d.getDate() + ', ' + d.getFullYear() + ' ' + hours + ':' + minutes + ':' + d.getSeconds() + ' ' + ampm;
    };

    $scope.isObjectEmpty = function(card) {
      return Object.keys(card).length === 0;
    }

    $scope.formatedJsonFile = [];

    $scope.getJsonAlerts = function(teamName, current) {
      $scope.errorCallback = false;
      $scope.messageStatus = '';
      var loginService = loginPromise.startService($scope.loginData.username, $scope.loginData.password);
      var teamDataService = teamDataPromise.startService(teamName, $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, current, $scope.appVersion);
      var foundActiveAlert = false;
      var foundP1 = false;
      var foundP2 = false;
      if (current && teamName == 'amoc' || teamName == 'attmx') {
        $scope.amocCurrentP1Unresolved = false;
        $scope.amocCurrentP2Unresolved = false;
        $scope.amocCurrentP1Resolved = false;
        $scope.amocCurrentP2Resolved = false;
      }
      if (!current && teamName == 'amoc' || teamName == 'attmx') {
        $scope.amocHistoryP1 = false;
        $scope.amocHistoryP2 = false;
      }
      // $scope.resultData[teamName] = {};
      loginService.then(function(success) {
        teamDataService.then(
          function(response) {
            var newAlertedResponse = {};
            foundActiveAlert = false;
            if (current && teamName == 'amoc') {
              $scope.amocCurrentP1Unresolved = false;
              $scope.amocCurrentP2Unresolved = false;
              $scope.amocCurrentP34Unresolved = false;
              $scope.amocCurrentP1Resolved = false;
              $scope.amocCurrentP2Resolved = false;
              $scope.amocCurrentP34Resolved = false;
            }
            if (!current && teamName == 'amoc') {
              $scope.amocHistoryP1 = false;
              $scope.amocHistoryP2 = false;
              $scope.amocHistoryP34 = false;
            }
            angular.forEach(response, function(data) { //reseting all the slide data
              angular.forEach(data.palerts, function(perfalert) {
                $scope.resultData[teamName][perfalert.displayPage.toLowerCase()] = [];
              });
            });

            angular.forEach($scope.resultData[teamName], function(array, key) {
              if (array.constructor === Array) {
                angular.forEach(response, function(application) {
                  var applicationAux = JSON.parse(JSON.stringify(application));
                  applicationAux.palerts = [];
                  var found = false;
                  angular.forEach(application.palerts, function(perfalert) {
                    if (perfalert.displayPage.toLowerCase() == key && !found) {
                      applicationAux.p1alertNumbers = 0;
                      applicationAux.p2alertNumbers = 0;
                      applicationAux.p34alertNumbers = 0;
                      applicationAux.alertNumbers = 0;
                      $scope.resultData[teamName][key].push(applicationAux);
                      found = true;
                    }
                  });
                });
              }
            });
            angular.forEach(response, function(application) {
              angular.forEach(application.palerts, function(perfalert) {
                angular.forEach($scope.resultData[teamName], function(array, key) {
                  if (array.constructor === Array && perfalert.displayPage.toLowerCase() == key) {
                    angular.forEach(array, function(applicationInJson) {
                      if (applicationInJson.name == perfalert.applicationName) {
                        if (perfalert.displayPage.toLowerCase() == 'ongoing') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocCurrentP1Unresolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocCurrentP2Unresolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocCurrentP34Unresolved = true;
                          }
                        }
                        if (perfalert.displayPage.toLowerCase() == 'resolved') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocCurrentP1Resolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocCurrentP2Resolved = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocCurrentP34Resolved = true;
                          }
                        }
                        if (perfalert.displayPage.toLowerCase() == 'history') {
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            $scope.amocHistoryP1 = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2') {
                            $scope.amocHistoryP2 = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            $scope.amocHistoryP34 = true;
                          }
                        }
                        applicationInJson.colorStatus = {
                          background: '#FFF',
                          color: '#79B509',
                          border: '2px solid #79B509'
                        };
                        applicationInJson.colorStatusBox = {
                          background: '#FFF',
                          color: '#79B509'
                        };
                        if (perfalert.priority.toUpperCase() == 'P1') {
                          applicationInJson.p1alertNumbers += 1;
                        }
                        if (perfalert.priority.toUpperCase() == 'P2') {
                          applicationInJson.p2alertNumbers += 1;
                        }
                        if (perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                          applicationInJson.p34alertNumbers += 1;
                        }
                        if (perfalert.status.toUpperCase() != 'RESOLVED') {
                          if (perfalert.priority.toUpperCase() == 'P0') {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: '#FF4646',
                              border: '2px solid #FF4646'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: '#FF4646',
                            };
                          }
                          if (perfalert.priority.toUpperCase() == 'P1') {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: '#FF4646',
                              border: '2px solid #FF4646'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: '#FF4646',
                            };
                            foundP1 = true;
                          }
                          if (perfalert.priority.toUpperCase() == 'P2' ||
                            perfalert.priority.toUpperCase() == 'P3' || perfalert.priority.toUpperCase() == 'P4') {
                            applicationInJson.colorStatus = {
                              background: '#FFF',
                              color: 'orange',
                              border: '2px solid orange'
                            };
                            applicationInJson.colorStatusBox = {
                              background: '#FFF',
                              color: 'orange',
                            };
                          }
                          foundActiveAlert = true;
                        }
                        applicationInJson.alertNumbers += 1;
                        applicationInJson.palerts.push(perfalert);
                      }
                    });
                  }
                });
              });
            });
            $scope.$broadcast('scroll.refreshComplete');
          },
          function(error) {
            $scope.errorCallback = true;
            $scope.$broadcast('scroll.refreshComplete');
            window.localStorage['current_page'] = 'palert';
            if (teamName.toLowerCase() == 'p0') {
              window.localStorage['current_page'] = 'palert_p0';
            }
            $scope.doLogin();
            // $scope.messageStatus = "We Came across an issue, please refresh";
          }
        );
      }, function(error) {
        alert('Please sign in again');
        $scope.isAuthenticated = false;
        $scope.loginMessage = '';
        $scope.hideBox = true;
        LoginService.setIsAuthenticated($scope.isAuthenticated);
        $state.go('app.login');
      });
    };



    if (window.localStorage['username'] != '' && window.localStorage['password'] != '' && window.localStorage['username'] != null && window.localStorage['password'] != null) {
      $scope.loginData.username = window.localStorage['username'];
      $scope.loginData.password = window.localStorage['password'];
      $scope.doLogin();
    }

    $scope.goBackHistory = function() {
      window.history.back();
    };

    //Function to sort json array dynamically. Use - to do reverse sort.
    $scope.dynamicSort = function(property) {
      var sortOrder = 1;
      if (property[0] === "-") {
        sortOrder = -1;
        property = property.substr(1);
      }
      return function(a, b) {
        var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
        return result * sortOrder;
      }
    }

    $scope.shareHU = function() {

      var message = '<html><body>';
        
        for (var key in $scope.headsUpData) { 
        var val = $scope.headsUpData[key];
        if(key == 'History')
         {
                if(val.length>0)
                message = message + '<p><strong>' + key + ': </strong>';
                
                angular.forEach(val, function(item) {

                var updateLst = item[key];
                var histDate = '';
                var histDesc = '';
                $scope.val = [];
                                        
                histDate = item.histDate;
                histDesc = item.histDesc;
                val = histDate + " - "+histDesc; 
                message = message + '<ul><li>'+val +'</li></ul></p>';
                });
                
         }
                
        else{
        
          if (val !== undefined && val !== '' && val !== 'N/A' && val !== 'NA' && val !== 'na' && val !== '-' && val !== '0')
          message = message + '<p><strong>' + key + ': </strong>' + val + '</p>';
            
        }  
      
    }   
          
      message = message + '</body></html>';

      var subject = $scope.headsupSubject ;
      var toArr;
      var ccArr;
      var bccArr;
      var file;

      window.plugins.socialsharing.shareViaEmail(message, subject, toArr, ccArr, bccArr, file);
      
    }
    
    $scope.sharePerf = function() {
      //alert("in share perf");
      //alert(JSON.stringify($scope.palertdata));
      /*
      var message = '<html><body>' +
                    '<h3>Issue: </h3>' + $scope.palertdata.issue +
                    '<br><h3>Business Impact: </h3>'+ $scope.palertdata.businessImpact +
                    '<br><h3>Root Cause: </h3>'+ $scope.palertdata.rootCause +
                    '<br><h3>Start Date: </h3>'+ $scope.sdate +
                    '<br><h3>End Date: </h3>'+ $scope.edate +
                    '<br><h3>Resolution: </h3>'+ $scope.palertdata.resolution +
                    '<br><h3>Mitigation: </h3>'+ $scope.palertdata.mitigation +
                    '<br><h3>RM: </h3>'+ $scope.palertdata.rm +
                    '<br><h3>Degradation: </h3>'+ $scope.palertdata.degradation+
                    '<br><h3>Update Note: </h3>'+ $scope.palertdata.updateNote;

      angular.forEach($scope.palertdata.historyNotes, function(historyData) {
        message = message + "<br><h3>Update @ " + $scope.formatDate(historyData.date) + ": </h3>" + historyData.note;
      });

      message = message + '</body></html>';
      alert(message);
      */

      var message = '<html><body>';

      //alert(JSON.stringify($scope.palertdata));

      for (var key in $scope.palertdata) {
        var val = $scope.palertdata[key];
        if (val !== undefined && val !== '' && val !== 'N/A' && val !== 'NA' && val !== 'na' && val !== '-' && val !== '0')
          message = message + '<p><strong>' + key + ': </strong>' + val + '</p>';
      }

      for (key in $scope.updateNotes) {
        val = $scope.updateNotes[key];
        message = message + '<p><strong>' + key + ': </strong>' + val + '</p>';
      }
      message = message + '</body></html>';

      //alert(message);

      var subject = $scope.palertsubject;
      var toArr;
      var ccArr;
      var bccArr;
      var file;

      window.plugins.socialsharing.shareViaEmail(message, subject, toArr, ccArr, bccArr, file);


      /*cordova.plugins.email.open(

        {
          to: toArr,
          cc: ccArr,
          subject: subject,
          body: message
        }

      );
      */

    };


    $scope.shareImage = function() {

      var message = '<html><body>';
      message = message + "<strong>" + $scope.currentTeamName + "<strong> graph attached";
      message = message + '</body></html>';

      //alert(message);

      //alert($scope.currentImageURL);


      var subject = $scope.currentTeamName;
      var toArr;
      var ccArr;
      var bccArr;
      var file = $scope.currentImageURL;

      //alert("file is " + file);
      window.plugins.socialsharing.shareViaEmail(message, subject, toArr, ccArr, bccArr, file);

      /* cordova.plugins.email.open(
        {
          to: toArr,
          cc: ccArr,
          subject: subject,
          body: message,
          isHtml:  true,
          attachments : [file]
        }
      );
      */
      //alert("After Sharing");

    };
 	$scope.shareHeadsUp = false;
    $scope.share = function() {

    //  alert($scope.currentTeamName);
     /* switch ($scope.currentTeamName) {
        case 'Perf Stats':
        case 'DTV Dashboard':
        case 'PSG Friday Flash':
        case 'PSG Bulletin':
		case 'Work Tracking Tool':
		case '1802 Deployment':
		case 'WR Statistics':
		case 'AOTS Stats':
		case 'TDP Stats':
		case 'Uverse Defect Metrics':
          $scope.shareImage();
          break;
        default:
          $scope.sharePerf();
      }*/
	  if($scope.currentTeamName)
	  {
		 $scope.shareImage();
	  }
	  else
	  {
           if($scope.shareHeadsUp)
            {
                 $scope.shareHU();   
            }
             
           else
           {
               $scope.sharePerf();
           }
	  }
    };
    $interval(function() {
      angular.forEach($scope.urlData, function(data) {
        // alert(JSON.stringify(data));
        if (data.parameter === 'p0' ||
          data.parameter === 'amoc' ||
          data.parameter === 'attmx') {
          $scope.getJsonAlerts(data.parameter, true);
        }
      });
      // Check if 3D Touch is supported on the device
      //if (window.ThreeDeeTouch) {
      if (window.ThreeDeeTouch) {
        window.ThreeDeeTouch.isAvailable(function(available) {
          if (available) {
            var countP0 = 0; // p0
            var countP1 = 0; // perf
            alertCountACL = countDataPromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
            alertCountACL.then(function(countArray) {
              angular.forEach(countArray, function(count) {
                if (count.priority.toLowerCase() === 'p1') {
                  countP1 += parseInt(count.openAlertsCount);
                } else if (count.priority.toLowerCase() === 'p0') {
                  countP0 += parseInt(count.openAlertsCount);
                }
              });
              var qucikAct = QuickActionService.configure(countP0, countP1);
            }, function(errorMessage) {
              alert(errorMessage)
            });
          }
        });
      }
    }, 1000 * 60 * 15);
    $interval(function() {
      if ($scope.isAuthenticated) {
        var loginService = loginPromise.startService($scope.loginData.username, $scope.loginData.password);
        loginService.then(
          function(success) {
            $scope.isAuthenticated = true;
            LoginService.setIsAuthenticated($scope.isAuthenticated);
          },
          function(error) {
            alert("We're currently unable to log you in. Please try again after some time.");
            $scope.hideBox = false;
            LoginService.setIsAuthenticated($scope.isAuthenticated);
            $scope.loginMessage = error.data;
          }
        );
      }
    }, 1000 * 60 * 30);
  })
