angular.module('starter.controllers')
  .controller('notificationCtrl', function($scope, $stateParams, $http, $ionicHistory, $timeout, $ionicLoading, LoginService, $q, loginPromise, teamDataPromise) {
    $scope.$on('$ionicView.enter', function(e) {
      $ionicLoading.show();
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.shareHeadsUp = false ;
      $scope.custom = true;
      $scope.moreless = 'More ...';
      $scope.toggleCustom = function() {
        $scope.custom = $scope.custom === false ? true : false;
        $scope.moreless = $scope.custom === true ? 'More ...' : 'Less ...';
      };
      $scope.updateNoteCount = 0;
      $scope.updateNotes = {};
      // $scope.getLogin = $scope.doLogin();
      $scope.getLogin = loginPromise.startService($scope.$parent.$parent.loginData.username, $scope.$parent.$parent.loginData.password);
      // alert('GETTING THE LOGIN INFORMATION');
      // $scope.messageStatus = 'Logging in ...';
      $scope.responseData = {};
      $scope.statusColor = {
        color: 'orange'
      };
      $scope.getLogin.then(
        function(success) {
          // alert('GETTING THE TEAM DATA');
          // $scope.teamData = $scope.getTeamData();
          $scope.teamData = teamDataPromise.startService($scope.$parent.$parent.perfNotification.additionalData.team, $scope.$parent.$parent.loginData.username, $scope.$parent.$parent.getTimeFormat(), $scope.$parent.$parent.myDeviceFullInfo, true, $scope.$parent.$parent.appVersion);
          $scope.teamData.then(
            function(success) {
              // alert('SUCCESS WE HAVE THE DATA');
              // $scope.messageStatus = 'Finding the data ...';
              $scope.responseData = success;
              angular.forEach($scope.responseData, function(wholeList) {
                angular.forEach(wholeList.palerts, function(palertdata) {
                  // $scope.messageStatus = "Rendering Data, please wait for id " + palertdata.id;
                  if (palertdata.id == $scope.$parent.$parent.perfNotification.additionalData.palertid) {
                    // $scope.messageStatus = "found the data for id " + palertdata.id;
                    // alert($scope.messageStatus);
                    $scope.$parent.$parent.currentStatus = palertdata.status;
                    $scope.$parent.$parent.currentApplication = $stateParams.application;
                    //  alert('Please Wait for Id: ' + palertdata.id);
                    if ($stateParams.teamname == $scope.$parent.$parent.defaultApplication) { //THIS IS JUST FOR P0 ALERTS.. THE REST WILL BE SHOWN AS IS
                      $scope.palertdata = {
                        // 'Priority' : palertdata.priority,
                        'Issue': palertdata.issue,
                        'Business Impact': palertdata.businessImpact,
                        'Status': palertdata.updateNote,
                      };
                      angular.forEach(palertdata.historyNotes, function(historyData) {
                        $scope.updateNoteCount += 1;
                        $scope.updateNotes["Status @ " + $scope.$parent.$parent.formatDate(historyData.date)] = historyData.note;
                      });
                    } else {
                      $scope.messageStatus = 'Perf Alert, please stand by..';
                      var sdate = '';
                      if (palertdata.startDate) {
                        // alert(palertdata.startDate != 'undefined');
                        sdate = $scope.$parent.$parent.formatDate(palertdata.startDate);
                      }
                      var edate = '';
                      if (palertdata.endDate) {
                        // alert(palertdata.endDate);
                        edate = $scope.$parent.$parent.formatDate(palertdata.endDate);
                      }
                      $scope.palertdata = {
                        // 'Priority': palertdata.priority,
                        'Issue': palertdata.issue,
                        'Business Impact': palertdata.businessImpact,
                        'Root Cause': palertdata.rootCause,
                        'Start Date': sdate,
                        'End Date': edate,
                        'Resolution': palertdata.resolution,
                        'Mitigation': palertdata.mitigation,
                        'Q Chat Link': palertdata.qchatLink,
                        'RM': palertdata.rm,
                        'Degradation': palertdata.degradation,
                        'Update Note': palertdata.updateNote,
                      };
                      angular.forEach(palertdata.historyNotes, function(historyData) {
                        $scope.updateNoteCount += 1;
                        $scope.updateNotes["Update @ " + $scope.$parent.$parent.formatDate(historyData.date)] = historyData.note;
                      });
                      $scope.palertdata['Bridge'] = '';
                      if (palertdata.bridge && palertdata.bridge.phoneNumber) {
                        console.log(palertdata.bridge.phoneNumber);
                        if (palertdata.bridge.phoneNumber.includes('.com')) { //contains link
                          if (palertdata.bridge.phoneNumber.includes(' ')) { //with spaces
                            var bridgedtl = palertdata.bridge.phoneNumber;
                            var number1 = null;
                            var bridge1 = null;
                            var url1 = null;
                            var arr = palertdata.bridge.phoneNumber.replace(',,', ' ,, ').replace('#', '# ').replace('  ', ' ').split(' ');
                            angular.forEach(arr, function(item, index) {
                              console.log(item, index);
                              if (item.includes('.com')) {
                                url1 = item;
                                console.log('url1:' + url1);
                              } else if (item.includes('#') || item.length == 7) {
                                bridge1 = item.includes('#') ? item : item + '#';
                                console.log('bridge1:' + bridge1);
                              } else if (item.length > 9) {
                                number1 = item;
                                console.log('number1:' + number1);
                              }
                            });

                            var bridgetotal = '';
                            if (number1 != null && bridge1 != null) {
                              bridgetotal = bridgetotal + '<a href="tel:' + number1.replace(/-/g, "") + ',,' + bridge1 + '">' + number1 + ',,' + bridge1 + '</a>' + '</br></br>';
                            }
                            if (url1 != null) {
                              bridgetotal = bridgetotal + '<a href="' + (url1.includes('http') ? url1 : 'http://' + url1) + '">  ' + url1 + '</a>';
                            }
                            $scope.palertdata['Bridge'] = bridgetotal;
                          } else { //without spaces
                            var bridgedtl = palertdata.bridge.phoneNumber;
                            var number1 = null;
                            var bridge1 = null;
                            var url1 = null;
                            var arr = palertdata.bridge.phoneNumber.replace(',,', ' ,, ').replace('#', '# ').split(' ');
                            angular.forEach(arr, function(item, index) {
                              console.log(item, index);
                              if (item.includes('.com')) {
                                url1 = item;
                                console.log('url1:' + url1);
                              } else if (item.includes('#') || item.length == 7) {
                                bridge1 = item.includes('#') ? item : item + '#';
                                console.log('bridge1:' + bridge1);
                              } else if (item.length > 9 && item.includes('-')) {
                                number1 = item;
                                console.log('number1:' + number1);
                              }
                            });

                            var bridgetotal = '';
                            if (number1 != null && bridge1 != null) {
                              bridgetotal = bridgetotal + '<a href="tel:' + number1.replace(/-/g, "") + ',,' + bridge1 + '">' + number1 + ',,' + bridge1 + '</a>' + '</br></br>';
                            }
                            if (url1 != null) {
                              bridgetotal = bridgetotal + '<a href="' + (url1.includes('http') ? url1 : 'http://' + url1) + '">  ' + url1 + '</a>';
                            }
                            $scope.palertdata['Bridge'] = bridgetotal;
                          }
                        } else {
                          $scope.palertdata['Bridge'] = palertdata.bridge.phoneNumber;
                        }
                      }
                      $scope.palertdata['AOTS'] = palertdata.aots;
                    }

                    if ($stateParams.teamname == $scope.$parent.$parent.defaultApplication && palertdata.status.toUpperCase() != 'RESOLVED') {
                      $scope.statusColor = {
                        color: '#FF4646'
                      };
                    } else {
                      if (palertdata.status.toUpperCase() == 'RESOLVED') {
                        $scope.statusColor = {
                          color: '#79B509'
                        };
                      } else {
                        if (palertdata.priority != undefined) {
                          if (palertdata.priority.toUpperCase() == 'P1') {
                            $scope.statusColor = {
                              color: '#FF4646'
                            };
                          }
                        }
                      }
                    }
                    $scope.messageStatus = 'Setting teamname and application names';
                    $scope.$parent.$parent.currentTeamName = '';
                    $scope.$parent.$parent.currentTeamName2 = palertdata.priority.toUpperCase();

                    //alert(JSON.stringify(palertdata));
                    $scope.$parent.$parent.palertdata = JSON.parse(JSON.stringify($scope.palertdata));
                    $scope.$parent.$parent.updateNotes = JSON.parse(JSON.stringify($scope.updateNotes));
                    $scope.$parent.$parent.palertsubject = palertdata.subject;
                  }
                });
              });
              // $scope.$parent.$parent.currentTeamName2 = $scope.$parent.$parent.resultData[$scope.$parent.$parent.perfNotification.additionalData.team].teamname;
              $scope.$parent.$parent.currentTeamName = '';
              $scope.$parent.$parent.currentApplication = $scope.$parent.$parent.perfNotification.additionalData.application;
              $scope.messageStatus = "";
              $scope.palertid = $scope.$parent.$parent.perfNotification.additionalData.palertid;
              $ionicLoading.hide();
            },
            function(error) {

            }
          );
        },
        function(error) {
          alert('We have an issue loggin in');
          $ionicLoading.hide();
          $scope.$broadcast('scroll.refreshComplete');
          window.localStorage['current_page'] = '';
          $scope.$parent.$parent.doLogin();
        }
      );

    });
  })