angular.module('starter.controllers')
  .controller('PalertCtrl', function($scope, $stateParams, $http, $ionicHistory) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.shareHeadsUp = false ;
      $scope.custom = true;
      $scope.moreless = 'More ...';
      $scope.toggleCustom = function() {
        $scope.custom = $scope.custom === false ? true : false;
        $scope.moreless = $scope.custom === true ? 'More ...' : 'Less ...';
      };
      $scope.$parent.$parent.inDetailpage = true;
      $('#mainmenuid').hide();

      $scope.goBackHistory = function() {
        $ionicViewSwitcher.nextDirection('back');
        $ionicHistory.goBack();
      };
      $scope.updateNoteCount = 0;
      $scope.teamname = $stateParams.teamname;
      $scope.application = $stateParams.application;
      $scope.palertid = $stateParams.palertid;
      $scope.statusColor = {
        color: 'orange'
      };
      $scope.current = $stateParams.current;
      delete $scope.palertdata;
      $scope.updateNotes = {};
      var alertDetails = [];
      // if ($stateParams.current == 'true') {
      //   alertDetails = $scope.$parent.$parent.resultData[$stateParams.teamname].current;
      // }
      // if ($stateParams.current == 'false') {
      //   alertDetails = $scope.$parent.$parent.resultData[$stateParams.teamname].history;
      // }
      angular.forEach($scope.$parent.$parent.resultData[$stateParams.teamname], function(wholeList) {
        if (wholeList.constructor === Array) {
          alertDetails = alertDetails.concat(wholeList);
        }
      });
      angular.forEach(alertDetails, function(wholeList) {
        angular.forEach(wholeList.palerts, function(palertdata) {
          if (palertdata.id == $scope.palertid) {
            if ($stateParams.teamname == $scope.$parent.$parent.defaultApplication) { //THIS IS JUST FOR P0 ALERTS.. THE REST WILL BE SHOWN AS IS
              $scope.palertdata = {
                // 'Priority' : palertdata.priority,
                'Issue': palertdata.issue,
                'Business Impact': palertdata.businessImpact,
                'Status': palertdata.updateNote,
              };
              angular.forEach(palertdata.historyNotes, function(historyData) {
                $scope.updateNoteCount += 1;
                $scope.updateNotes["Status @ " + $scope.$parent.$parent.formatDate(historyData.date)] = historyData.note;
              });
            } else {
              var sdate = '';
              if (palertdata.startDate) {
                // alert(palertdata.startDate != 'undefined');
                sdate = $scope.$parent.$parent.formatDate(palertdata.startDate);
              }
              var edate = '';
              if (palertdata.endDate) {
                // alert(palertdata.endDate);
                edate = $scope.$parent.$parent.formatDate(palertdata.endDate);
              }
              $scope.palertdata = {
                // 'Priority': palertdata.priority,
                'Issue': palertdata.issue,
                'Business Impact': palertdata.businessImpact,
                'Root Cause': palertdata.rootCause,
                'Start Date': sdate,
                'End Date': edate,
                'Resolution': palertdata.resolution,
                'Mitigation': palertdata.mitigation,
                'Q Chat Link': palertdata.qchatLink,
              };
              if (palertdata.rm != undefined) {
                $scope.palertdata['RM'] = palertdata.rm;
              };
              $scope.palertdata['Degradation'] = palertdata.degradation;
              $scope.palertdata['Update Note'] = palertdata.updateNote;
              angular.forEach(palertdata.historyNotes, function(historyData) {
                $scope.updateNoteCount += 1;
                $scope.updateNotes["Update @ " + $scope.$parent.$parent.formatDate(historyData.date)] = historyData.note;
              });
              $scope.palertdata['Bridge'] = '';
              if (palertdata.bridge && palertdata.bridge.phoneNumber) {
                //$scope.palertdata['Bridge'] = palertdata.bridge.phoneNumber;
                //$scope.palertdata['Bridge'] = palertdata.bridge.phoneNumber+'testingcall';
				        //$scope.palertdata['Bridge'] = Uri.parse("tel:"+{{mySplit(palertdata.bridge.phoneNumber,0)}}) +',,'+ {{mySplit(palertdata.bridge.phoneNumber,2)}} +'#'+ {{mySplit(palertdata.bridge.phoneNumber,3)}};
				        //$scope.palertdata['Bridge'] = Uri.parse("tel:"+palertdata.bridge.phoneNumber.split(' ')[0]) +',,'+ palertdata.bridge.phoneNumber.split(' ')[2] +'#'+ palertdata.bridge.phoneNumber.split(' ')[3];
						console.log(palertdata.bridge.phoneNumber);
				            if (palertdata.bridge.phoneNumber.includes('.com') || (palertdata.bridge.phoneNumber.includes(',') && palertdata.bridge.phoneNumber.includes('#'))) {//contains link
								if(palertdata.bridge.phoneNumber.includes(' ')){//with spaces
					                var bridgedtl = palertdata.bridge.phoneNumber;
									var number1=null;
									var bridge1=null;
									var url1=null;
									var arr = palertdata.bridge.phoneNumber.replace(',,',' ,, ').replace('#','# ').replace('  ',' ').split(' ');
									angular.forEach(arr, function(item, index) {
										console.log(item, index);
										if(item.includes('.com')){
											url1=item;
											console.log('url1:'+url1);
										}
										else if(item.includes('#') || item.length==7){
											bridge1=item.includes('#')?item:item+'#';
											console.log('bridge1:'+bridge1);
										}
										else if(item.length>9){
											number1=item;
											console.log('number1:'+number1);
										}
									});
									
									var bridgetotal = '';
									if(number1 != null && bridge1 != null){
										bridgetotal = bridgetotal + '<a href="tel:'+number1.replace(/-/g , "")+',,'+bridge1+'">' +number1+ ',,'+bridge1+'</a>' +'</br></br>';
									}
									if(url1 != null){
										bridgetotal = bridgetotal + '<a href="'+ (url1.includes('http')?url1:'http://'+url1)+'">  '+url1+'</a>';
									}
									$scope.palertdata['Bridge'] = bridgetotal;
								}
								else{//without spaces
									var bridgedtl = palertdata.bridge.phoneNumber;
									var number1=null;
									var bridge1=null;
									var url1=null;
									var arr = palertdata.bridge.phoneNumber.replace(',,',' ,, ').replace('#','# ').split(' ');
									angular.forEach(arr, function(item, index) {
										console.log(item, index);
										if(item.includes('.com')){
											url1=item;
											console.log('url1:'+url1);
										}
										else if(item.includes('#') || item.length==7){
											bridge1=item.includes('#')?item:item+'#';
											console.log('bridge1:'+bridge1);
										}
										else if(item.length>9 && item.includes('-')){
											number1=item;
											console.log('number1:'+number1);
										}
									});
									
									var bridgetotal = '';
									if(number1 != null && bridge1 != null){
										bridgetotal = bridgetotal + '<a href="tel:'+number1.replace(/-/g , "")+',,'+bridge1+'">' +number1+ ',,'+bridge1+'</a>' +'</br></br>';
									}
									if(url1 != null){
										bridgetotal = bridgetotal + '<a href="'+ (url1.includes('http')?url1:'http://'+url1)+'">  '+url1+'</a>';
									}
									$scope.palertdata['Bridge'] = bridgetotal;
									
								}
									
									
									
					                 //var number = palertdata.bridge.phoneNumber.replace('  ',' ').split(' ')[0];
					                 //var bridgepc = palertdata.bridge.phoneNumber.replace('  ',' ').split(' ')[2];
					                 //var urlconnect = palertdata.bridge.phoneNumber.replace('  ',' ').split(' ')[3];
					                 //Uri urinum = Uri.parse('tel:'+number.replace(/-/g , ''));
					                 //$scope.palertdata['Bridge'] = '<a onclick="window.plugins.CallNumber.callNumber(onSuccess, onError, '+number.replace(/-/g , "")+', false)">' +number+ '</a>' +',,'+bridgepc+'#'+'<a href="'+ (urlconnect.includes('http')?urlconnect:'http://'+urlconnect)+'">  '+urlconnect+'</a>';
					                 //$scope.palertdata['Bridge'] = '<a href="tel:'+number.replace(/-/g , "")+'">' +number+ ',,'+bridgepc+'</a>' +' '+'</br></br> <a href="'+ (urlconnect.includes('http')?urlconnect:'http://'+urlconnect)+'">  '+urlconnect+'</a>';
					                 //window.plugins.CallNumber.callNumber(onSuccess, onError, number, bypassAppChooser);
							}
							else {
							$scope.palertdata['Bridge'] = palertdata.bridge.phoneNumber;
							}
              }
              $scope.palertdata['AOTS'] = palertdata.aotsTicketNumber;
            }

            if ($stateParams.teamname == $scope.$parent.$parent.defaultApplication && palertdata.status.toUpperCase() != 'RESOLVED') {
              $scope.statusColor = {
                color: '#FF4646'
              };
            } else {
              if (palertdata.status.toUpperCase() == 'RESOLVED') {
                $scope.statusColor = {
                  color: '#79B509'
                };
              } else {
                if (palertdata.priority != undefined) {
                  if (palertdata.priority.toUpperCase() == 'P1') {
                    $scope.statusColor = {
                      color: '#FF4646'
                    };
                  }
                }
              }
            }
            $scope.$parent.$parent.currentTeamName2 = palertdata.priority.toUpperCase();
            $scope.$parent.$parent.currentStatus = palertdata.status;

            //alert(JSON.stringify(palertdata));
            $scope.$parent.$parent.palertdata = JSON.parse(JSON.stringify($scope.palertdata));
            $scope.$parent.$parent.updateNotes = JSON.parse(JSON.stringify($scope.updateNotes));
            $scope.$parent.$parent.palertsubject = palertdata.subject;
          }
        });
      });
      // $scope.$parent.$parent.currentTeamName2 = $scope.$parent.$parent.resultData[$stateParams.teamname].teamname;
      $scope.$parent.$parent.currentTeamName = '';
      $scope.$parent.$parent.currentApplication = $stateParams.application;
    });
  })
