angular.module('starter.controllers')
.controller('unifiedDashboardCtrl', function($scope, $stateParams, $http, $ionicLoading, $window, $ionicHistory, graphsPromise, $state,$ionicModal,graphService,$log) {
  $scope.$on('$ionicView.enter', function(e) {
	  $ionicLoading.show();
    $scope.$parent.$parent.inDetailpage = false;
    $('#mainmenuid').show();
    delete $scope.$parent.$parent.currentTeamName;
    delete $scope.$parent.$parent.currentApplication;
    delete $scope.$parent.$parent.currentStatus;
    $scope.$parent.$parent.shareOnAppPage = false;
    $scope.$parent.$parent.currentTeamName = 'Unified Dashboard';
	getUdashJson();
  });
  
  $scope.windowWidth = $window.innerWidth;
  /*$scope.windowHeight = $window.innerHeight;
  alert($scope.windowWidth);
  alert($scope.windowHeight);*/
  
  $scope.reloadGraph = function() {
    $state.reload();
  }
  $scope.overAllCount = {};
  
  $scope.toggleGroup = function(group) {
    if ($scope.isGroupShown(group)) {
      $scope.shownGroup = null;
    } else {
      $scope.shownGroup = group;
    }
  };
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup === group;
  };

  function gatherCount() {
    //ITERATES THE CODE AND COUNTS THE NUMBER OF YELLOW AND RED ALERTS DISPLAYED
    $http.post("json_files/SNOOZE_HISTORY.json").then(function(response) {
      $.each($scope.content, function(i, dashInformation) {
        dashInformation.yellow = dashInformation.categoryName == 'Payments EMAS BDS' ? $scope.yellowCountApp + $scope.yellowCountSys : 0;
        dashInformation.red = dashInformation.categoryName == 'Payments EMAS BDS' ? $scope.redCountApp + $scope.redCountSys : 0;
        dashInformation.green = dashInformation.categoryName == 'Payments EMAS BDS' ? $scope.greenCountApp + $scope.greenCountSys : 0;
        $.each(dashInformation.appInformation, function(j, alertData) {
          $.each(alertData.appClass, function(k, alertsDetails) {
            $.each(alertsDetails, function(l, alerts) {
              alerts.yellowCount = 0;
              alerts.greenCount = 0;
              alerts.redCount = 0;
              $.each(alerts.alerts, function(m, alert) {
                $.each(alert, function(n, alertinfo) {
                  if (alertinfo.color != undefined) {
                    alert.count = parseInt(alert.count);
                    angular.forEach(response.data, function(dataRow) {
                      alertinfo.hasSnooze = false;
                      if (alertinfo.alert_id === dataRow[1]) {
                        alertinfo.hasSnooze = true;
                        if (alerts.color == 'GREEN' && (dataRow[4] == 'YELLOW' || dataRow[4] == 'RED')) {
                          alerts.color = dataRow[4];
                        }
                        if (alerts.color == 'YELLOW' && dataRow[4] == 'RED') {
                          alerts.color = dataRow[4];
                        }
                        alertinfo.countSnooze = 0;
                        alertinfo.countSnooze = dataRow[6];
                        if (alertinfo.color == 'GREEN' || dataRow[4] == 'GREEN') {
                          alertinfo.priority = '5';
                        }
                        alertinfo.color = dataRow[4];
                        if (alertinfo.count - dataRow[6] < 0) {
                          //alertinfo.count = 0;
                          //alertinfo.countSnooze = 0;
                        }
                      }
                    });
                    if (alertinfo.color === 'GREEN' && alertinfo.count > 0) {
                      dashInformation.green++;
                      alerts.greenCount++;
                    }
                    if (alertinfo.color === 'YELLOW') {
                      dashInformation.yellow++;
                      alerts.yellowCount++;
                    }
                    if (alertinfo.color === 'RED') {
                      dashInformation.red++;
                      alerts.redCount++;
                    }
                  }
                });
              });
            });
          });
        });
      });
      $.each($scope.content, function(i, dashInformation) {
        $.each(dashInformation.appInformation, function(j, alertData) {
          $.each(alertData.appClass, function(k, alertsDetails) {
            $.each(alertsDetails, function(l, alerts) {
              if (alerts.redCount > 0) {
                alerts.color = "RED";
              }
              if (alerts.yellowCount > 0 && alerts.redCount == 0) {
                alerts.color = "YELLOW";
              }
              if (alerts.greenCount > 0 && alerts.yellowCount == 0 && alerts.redCount == 0) {
                alerts.color = "GREEN";
              }
            });
          });
        });
      });
    });
    // console.log($scope.content);
  }

  function gatherCountPay() {
    //ITERATES THE CODE AND COUNTS THE NUMBER OF YELLOW AND RED ALERTS DISPLAYED
    $scope.yellowCountSys = 0;
    $scope.greenCountSys = 0;
    $scope.redCountSys = 0;
    $scope.yellowCountApp = 0;
    $scope.greenCountApp = 0;
    $scope.redCountApp = 0;
    $scope.paymentsColorSys = 'GREEN';
    $scope.paymentsColorApp = 'GREEN';
    $.each($scope.contentPay, function(i, dashInformation) {
      $.each(dashInformation.appInformation, function(j, alertData) {
        $.each(alertData.appClass, function(k, alertsDetails) {
          $.each(alertsDetails, function(l, alerts) {
            $.each(alerts.alerts, function(m, alert) {
              $.each(alert, function(n, alertinfo) {
                if (typeof alertinfo.color !== "undefined") {
                  alert.count = parseInt(alert.count);
                  if (alertinfo.color === 'GREEN' && alertinfo.count > 0) {
                    if (alerts.appType == 'System') {
                      $scope.greenCountSys++;
                    }
                    if (alerts.appType == 'Application') {
                      $scope.greenCountApp++;
                    }
                  }
                  if (alertinfo.color === 'YELLOW') {
                    if (alerts.appType == 'System') {
                      $scope.yellowCountSys++;
                    }
                    if (alerts.appType == 'Application') {
                      $scope.yellowCountApp++;
                    }
                  }
                  if (alertinfo.color === 'RED') {
                    if (alerts.appType == 'System') {
                      $scope.redCountSys++;
                    }
                    if (alerts.appType == 'Application') {
                      $scope.redCountApp++;
                    }
                  }
                }
              });
            });
          });
        });
      });
    });
    if ($scope.yellowCountSys > 0) {
      $scope.paymentsColorSys = 'YELLOW';
    }
    if ($scope.yellowCountApp > 0) {
      $scope.paymentsColorApp = 'YELLOW';
    }
    if ($scope.redCountSys > 0) {
      $scope.paymentsColorSys = 'RED';
    }
    if ($scope.redCountApp > 0) {
      $scope.paymentsColorApp = 'RED';
    }
    $scope.overAllCount.yellow += $scope.yellowCountApp + $scope.yellowCountSys;
    $scope.overAllCount.red += $scope.redCountApp + $scope.redCountSys;
    $scope.overAllCount.green += $scope.greenCountApp + $scope.greenCountSys;
  }

  function getUdashJson() {
    $scope.overAllCount.red = 0;
    $scope.overAllCount.yellow = 0;
    $scope.overAllCount.green = 0;
    var graphSet = ['pay_cat_app_mapping_mobile.json','udash_cat_app_mapping_mobile.json'];
    graphService.startService(graphSet, $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion).then(function(responseArray) {
      angular.forEach(responseArray, function(response,i) {
        if(i == 1){
          $scope.content = response;
          $scope.timestamp = response[Object.keys(response).length - 1].timestamp;
          $scope.content.pop(); //REMOVE TIMESTAMP FROM OBJECT
          $('#timestampIdLink').html("Last update: " + $scope.timestamp);
          gatherCountPay();
          gatherCount();
          $scope.gatherOverAllcount();
        }
        if(i == 0){
          $scope.contentPay = response;
          $scope.timestampPay = response[1].timestamp;
          $scope.contentPay.pop(); //REMOVE TIMESTAMP FROM OBJECT
        }
      });
    });

    // $http.get('json_files/udash_cat_app_mapping.json', {
    //   cache: false
    // }).success(function(response) {
    //   // $http.get('../../pay-unified-dashboard/json_files/udash_cat_app_mapping.json', {
    //   //   cache: false
    //   // }).success(function(responsePay) {
    //   //   if (responsePay != "") {
    //   //     $scope.contentPay = responsePay;
    //   //     $scope.timestampPay = responsePay[1].timestamp;
    //   //     $scope.contentPay.pop(); //REMOVE TIMESTAMP FROM OBJECT
    //   //     gatherCountPay();
    //   //   }
    //   // });
    //   //UDASH
    //   $scope.content = response;
    //   $scope.timestamp = response[Object.keys(response).length - 1].timestamp;
    //   $scope.content.pop(); //REMOVE TIMESTAMP FROM OBJECT
    //   $('#timestampIdLink').html("Last update: " + $scope.timestamp);
    //   //PAY / UDASH
    //   // gatherCountPay();
    //   gatherCount();
    //   $scope.gatherOverAllcount();
    // });

    // $('.grid').masonry({
    //   itemSelector: '.grid-item',
    //   percentPosition: true,
    //   columnWidth: '.grid-sizer'
    // });
  }
  $scope.gatherOverAllcount = function() {
    $http.get('json_files/gaugeRules.json').success(function(response) {
      angular.forEach(response, function(cat) {
        angular.forEach($scope.content, function(category, key) {
          if (category.categoryName == cat.category) {
            var gaugeValue = .5;
			$scope.textcolor='green';
			$scope.content[key].linecolor = 'green';
			$scope.content[key].blink = '';
            if (cat.red <= category.red) {
              gaugeValue = 2.5;
			  $scope.textcolor='red';
			  $scope.content[key].linecolor = 'red';
			  $scope.content[key].blink = 'blinkHead';
            } else {
              if (cat.yellow <= category.yellow) {
                gaugeValue = 1.5;
				$scope.textcolor='yellow';
				$scope.content[key].linecolor = 'yellow';
				$scope.content[key].blink = '';
              }
            }
            var gauge_settings = {
              chart: {
                type: 'gauge',
                height: '90',
                backgroundColor: 'rgba(255, 255, 255, 0.0)',
                margin: 0,
                border: 0,
                padding: 0,
              },
              tooltip: {
                enabled: false,
              },
              credits: {
                enabled: false,
              },
              title: {
                text: ''
              },
              pane: {
                startAngle: -90,
                endAngle: 90,
                background: null
              },
              plotOptions: {
                gauge: {
                  dataLabels: {
                    enabled: false
                  },
                  dial: {
                    baseLength: '0%',
                    baseWidth: 10,
                    radius: '100%',
                    rearLength: '0%',
                    topWidth: 1
                  }
                }
              },
              // the value axis
              yAxis: {
                labels: {
                  enabled: false
                },
                minorTickLength: 0,
                min: 0,
                max: 3,
                tickLength: 0,
                plotBands: [{
                  from: 0,
                  to: 1,
                  color: '#39b54a', // green
                  thickness: '50%'
                }, {
                  from: 1,
                  to: 2,
                  color: '#fbb03b', // yellow
                  thickness: '50%'
                }, {
                  from: 2,
                  to: 3,

                  color: '#ff0000', // red
                  thickness: '50%'
                }]
              },
              series: [{
                name: '',
                data: [gaugeValue]
              }]
            };
            $('#' + cat.category.replace(/\s+/g, '').replace('&', '') + 'gauge_info').highcharts(gauge_settings);
          }
        });
      });
    });
	$ionicLoading.hide();
  };

  setInterval(function() {
    getUdashJson();
  }, 1000 * 60 / 1 * 3);
  // setInterval(function() {
  //   $scope.gatherOverAllcount();
  // }, 1000 * 30 / 1 * 1);
  $scope.showPopup = function(alerts, redirectUrl, category, application, type) {

    var text = "";
    $scope.modalTemplatetitle = category + ' : ' + application + ' : ' + type + ' Alerts';

    var alertData = [];
    var alertDataNull = [];
    var alertDataZeroGreen = [];
    var alertDataHighGreen = [];
    var alertDataYellow = [];
    var alertDataRed = [];
    $.each(alerts, function(i, alert1) {
      $.each(alert1, function(i, alert2) {
        if (!isEmpty(alert2)) {
          if (alert2.priority == 'Default') {
            alert2.priority = 10000;
          }
          alert2.count = parseInt(alert2.count);
          if (alert2.color === 'GREEN') {
            if (alert2.priority == 5 && alert2.count == 0) {
              alertDataZeroGreen.push(alert2);
            }
            if (alert2.priority == 5 && alert2.count > 0) {
              alertDataHighGreen.push(alert2);
            }
          }
          if (alert2.color === 'YELLOW') {
            alertDataYellow.push(alert2);
          }
          if (alert2.color === 'RED') {
            alertDataRed.push(alert2);
          }
        }
      });
    });
    //GREEN
    alertDataZeroGreen = sortByKey(alertDataZeroGreen, 'alert_id', 'desc');
    alertDataHighGreen = sortByKey(alertDataHighGreen, 'alert_id', 'asc');
    alertDataHighGreen = sortByKey(alertDataHighGreen, 'count', 'asc');
    //YELLOW
    alertDataYellow = sortByKey(alertDataYellow, 'alert_id', 'asc');
    alertDataYellow = sortByKey(alertDataYellow, 'count', 'asc');
    //RED
    alertDataRed = sortByKey(alertDataRed, 'alert_id', 'asc');
    alertDataRed = sortByKey(alertDataRed, 'count', 'asc');

    alertDataRed = $.merge(alertDataRed, alertDataYellow);
    alertDataRed = $.merge(alertDataRed, alertDataHighGreen);
    alertDataRed = $.merge(alertDataRed, alertDataZeroGreen);
    $scope.modalTemplatebody = alertDataRed;
    $scope.modalTemplateUrl = redirectUrl;
    $scope.openModal();
  };
  $scope.closeModal = function() {
    $('#modalPopupDiv').modal('hide');
  };

  $ionicModal.fromTemplateUrl('templates/udash-modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.openModal = function() {
    $scope.modal.show();
  };

  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  //Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
  // Execute action on hide modal
  $scope.$on('modal.hide', function() {
    // Execute action
  });
  // Execute action on remove modal
  $scope.$on('modal.removed', function() {
    // Execute action
  });
  $scope.$on('modal.shown', function() {
    console.log('Modal is shown!');
  });

  $scope.openSnoozeMenu = function(alert) {
    var url = 'json_files/user_acl_details.json';
    $scope.snooze = {};
    $scope.snooze.modalTemplatetitle = "Acknowledgement Options for " + alert.alert_id;
    $scope.snooze.alert = alert;
    $scope.snooze.snoozeByUser = [];
    $scope.timelapse = '';
    $('#ackButton').removeClass('disabled');
    // $scope.snooze.color = alert.color;
    $scope.snooze.attuid = $('#attuid').val();
    //$scope.snooze.attuid = 'JN389W';
    var colors = ['GREEN', 'YELLOW', 'RED'];
    $scope.colors = [];
    angular.forEach(colors, function(color) {
      $scope.colors.push({
        'value': color,
        'label': color.toUpperCase()
      });
    });
    $scope.snooze.last = {};
    $scope.snooze.last.attuid = "";
    $scope.snooze.last.message = "";
    $scope.snooze.last.color = "";
    $scope.snooze.last.c_date = "";

    $http.post("json_files/SNOOZE_HISTORY.json").then(function(response) {
      angular.forEach(response.data, function(dataRow) {
        if (dataRow[5] == 'Y' && dataRow[1] == alert.alert_id) {
          $scope.snooze.last.attuid = dataRow[0];
          $scope.snooze.last.message = dataRow[3].replace(';', ',');
          $scope.snooze.last.color = dataRow[4];
          $scope.snooze.last.c_date = dataRow[2];
        }
      });

      $('#reason').val('');
      $('#handleDiv').show();
      $('#modalSnoozeDiv').modal();
    });
  };
  $scope.handle = function() {
    var url = "php/dashBoard/snooze/form/snooze.php";
    $scope.snooze.timelapse = $('#timelapse').val();
    $scope.snooze.color = $('#color').val();
    $scope.snooze.reason = $('#reason').val();
    $scope.hideSnoozeValidation = false;
    $scope.snoozeValText = "";
    $scope.snoozeSubmit = true;
    $('#ackButton').addClass('disabled');
    if ($scope.snooze.reason.trim() == "") {
      $scope.snoozevalText = 'Plase type a reason';
      $scope.hideSnoozeValidation = true;
      return;
    }
    $scope.snooze.function = 'handle';
    $http.post(url, $scope.snooze).then(function(response) {
      $('#ackButton').removeClass('disabled');
      $scope.snoozeSubmit = true;
      $scope.snooze.color = '';
      $scope.snooze.reason = '';
      $('#modalSnoozeDiv').modal('toggle');
      $('#modalPopupDiv').modal('toggle');
    });
    $scope.snooze.last.attuid = $scope.snooze.attuid;
    $scope.snooze.last.message = $scope.snooze.reason;
    $scope.snooze.last.color = $scope.snooze.color;
    $scope.snooze.last.c_date = 'Just now';
  };
  $scope.handleForm = function() {
    $('#handleDiv').show();
  };
  $scope.snoozeAlert = function(time) {
    var url = "php/dashBoard/snooze/form/snooze.php";
    $scope.snooze.alert.function = 'snooze';
    $http.post(url, $scope.snooze.alert).then(function(response) {
      // console.log(response);
    });
  };
})
function sortByKey(array, key, sort) {
  return array.sort(function(a, b) {
    var x = a[key];
    var y = b[key];
    var result;
    if (sort == 'asc') {
      result = ((x > y) ? -1 : ((x < y) ? 1 : 0));
    } else {
      result = ((x < y) ? -1 : ((x > y) ? 1 : 0));
    }
    return result;
  });
}

function isEmpty(obj) {
  for (var prop in obj) {
    if (obj.hasOwnProperty(prop))
    return false;
  }

  return true && JSON.stringify(obj) === JSON.stringify({});
}

function blink_text() {
	$('.blinkHead').each(function(i, obj) {
		if($(this).css("backgroundColor")=="rgb(255, 0, 0)" || $(this).css("color")=="rgb(255, 0, 0)"){ // blink if red
			$('.blinkHead').fadeOut(1500);
			$('.blinkHead').fadeIn(1500);
		}
	});
}
setInterval(blink_text, 3000);