angular.module('starter.controllers')
.controller('updateAppCtrl', function($scope, $stateParams, $http, $ionicHistory, getAppUpdateService, $state) {
  $scope.$on('$ionicView.enter', function(e) {
    $scope.$parent.$parent.inDetailpage = false;
    $('#mainmenuid').show();
    delete $scope.$parent.$parent.currentTeamName;
    delete $scope.$parent.$parent.currentApplication;
    delete $scope.$parent.$parent.currentStatus;
    $scope.$parent.$parent.shareOnAppPage = false;
    $scope.$parent.$parent.currentTeamName = 'Updates';
    var appUpdateService = getAppUpdateService.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
    appUpdateService.then(
      function(success) {
        $scope.latestVersion = success.applicationUpdate.applicationVersion;
        $scope.latestUpdates = success.applicationUpdate.releaseNotes;
        $scope.downloadUrl = success.applicationUpdate.downloadUrl;
        $scope.updatesDetails = $scope.latestUpdates.split(':');
      },
      function(error) {
        alert("Got error while fetching the application updates.");
      }
    );
    $scope.update = function() {
      window.open($scope.downloadUrl, '_system', 'location=yes'); return false;
    };
  });
})
