angular.module('starter.controllers')
  .controller('wttCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal, getImagePromise, $state)  {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
	//$scope.imagesName = [];
    $scope.$on('$ionicView.enter', function(e) {
		$scope.$parent.$parent.inDetailpage = true;
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';

      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
	  
	  if ($stateParams.wttName == 'wr_statistics') {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'WR Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/wr_statistics/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wr_statistics', path, $scope.appVersion);
      
      }
	  else if($stateParams.wttName == 'aots_stats')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'AOTS Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/aots_stats/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'aots_stats', path, $scope.appVersion);
        
	  }
	   else if($stateParams.wttName == 'tdp_stats')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'TDP Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/tdp_stats/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'tdp_stats', path, $scope.appVersion);
        
	  }
	  
	  else if($stateParams.wttName == 'wtt_rfi')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'RFI Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/RFI/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wtt_rfi', path, $scope.appVersion);
        
	  }
	   else if($stateParams.wttName == 'wtt_itracks')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'iTracks Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/iTracks/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wtt_itracks', path, $scope.appVersion);
      }  
	  
	  else if($stateParams.wttName == 'wtt_clarify')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'Clarify Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/Clarify/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wtt_clarify', path, $scope.appVersion);
      } 
	  
	  else if($stateParams.wttName == 'wtt_reject')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'Reject Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/Reject/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wtt_reject', path, $scope.appVersion);
      } 
	  
	  else if($stateParams.wttName == 'wtt_trb')
	  {
	  $scope.slides = [];
      $scope.$parent.$parent.currentTeamName = 'TRB Statistics';
      var path = '/opt/app/aace/3psw/apache-tomcat-8.0.33/images/TRB/';
      var imageService = getImagePromise.startService($scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, 'wtt_trb', path, $scope.appVersion);
      } 
	  
      imageService.then(
        function(success) {
          angular.forEach(success.listOfImages, function(imageInfo) {
             var image = JSON.parse(imageInfo);
			var image_title=image.imageName.split(".");
           // $scope.images.push({'uri':image.imageUri,'title':image_title[0]});
			//$scope.imagesName.push(image_title[0]);
			
			$scope.images.push(image.imageUri);
            
          });
          $scope.$parent.$parent.currentImageURL = $scope.images[0];
          $ionicSlideBoxDelegate.update();
        },
        function(error) {
          alert("got error in images");
        }
      );
	  $scope.images = [];
    });
  
  })