angular.module('starter.controllers')
  .controller('aboutMenuCtrl', function($scope, $stateParams, $http, $ionicHistory, graphsPromise, $state) {
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = false;
      $('#mainmenuid').show();
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentTeamName = 'About';
    });
	
  $scope.groups = [{
      title: "What are Perf Alerts?",
      contents: [
        {
          line: "Performance alerts are notifications used for alerting IT personnel to current issues and outages, or for proactively alerting to a potential problem. Perf Alerts have four priorities: P1, P2, P3 and P4. P1 and P2 are potentially customer impacting."
        }
      ]
    },
	 {
      title: "What are P0 alerts?",
      contents: [
        {
          line: "P0 Alerts are major business impacting alerts that need management attention. They are only available to a restricted audience."
        }
      ]
    },
	{
      title: "What are Business Metrics?",
      contents: [
        {
          line: "Business Metrics are quantifiable measures that are used to track and assess the status of a specific business process. Business Metrics are divided by business line (such as Mobility, Uverse, etc.) and access granted as such."
        }
      ]
    },
	{
      title: "How do I report an issue in the app or provide a suggestion for a new feature?",
      contents: [
        {
          line: "Please send an email to amoc_tools@list.att.com. Please note the platform (Andriod or IOS) and the phone type (E.g., Samsung S8) where you faced the issue."
        }
      ]
    },
	{
      title: "How do I refresh a page on the app?",
      contents: [
        {
          line: "Simply pull down to refresh."
        }
      ]
    },
	{
      title: "Why don't I see all the items on the app?",
      contents: [
        {
          line: "Access is to each menu item is controlled at the user level. If you require additional access, please send an email to amoc_tools@list.att.com and it will be granted after evaluation."
        }
      ]
    }
  ];
  
  /*
   * if given group is the selected group, deselect it
   * else, select the given group
   */
  $scope.toggleGroup = function(group) {
    if ($scope.isGroupShown(group)) {
      $scope.shownGroup = null;
    } else {
      $scope.shownGroup = group;
    }
  };
  $scope.isGroupShown = function(group) {
    return $scope.shownGroup === group;
  };
  
  
  })
  
  
