angular.module('starter.controllers')
  .controller('davCtrl', function($scope, $stateParams, $http, $ionicHistory, fetchDavDataService,graphsPromise, $state, $ionicSlideBoxDelegate) {
    $scope.$on('$ionicView.enter', function(e) {
      $('#mainmenuid').hide();
      $scope.$parent.$parent.inDetailpage = true;
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.crData = {};
      $scope.disabled = true;//to enable/disable CRapproval button
      $scope.tittleflag = false;
      $scope.crApproval = false;
        if($stateParams.menu === 'crApproval') {
	  $scope.crApproval = true;
      $scope.$parent.$parent.currentTeamName = 'CR Approval';
       //Changes from Abbas/Sumit 
      var response =  fetchDavDataService.startService($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo,$scope.appVersion,'loadDeploymentData',$scope.getDavParams('loadDeploymentData', '', ''));
        response.then(
      function(success) {
        $scope.strResponse = success.strResponse;
        console.log($scope.strResponse);
        
        var res = JSON.parse($scope.strResponse);
        var message =res.message;
        var items = message.split('_');
            angular.forEach(items, function(item) {
                var data = item.split(':');
                $scope.crData[data[0]] = data[1];
            });
            $scope.title = res.notificationTitle; 
      			if($scope.crData['Approval Status'] === 'This List of CR needs to be Approved')
      				$scope.disabled = false;
      		
      },
      function(error) {
      	alert("Got error while fetching values.");
        alert("Got error while fetching the application updates.");
      }
    );
            
      }
        else if($stateParams.menu === 'deploymentStatus') {
            
            $scope.crApproval = false;
            $scope.$parent.$parent.currentTeamName = 'Deployment Status';
            var graphNames = ['DTV_ORDER_BY_CHNL_COLL'];
    angular.forEach(graphNames,function(value,key){
      $('#targetDivGraphs').append('<div class="col-lg-4 col-md-6 col-sm-12" id="graph'+value+'"></div>');
      var graphs = graphsPromise.startService(value+'.json', $scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
      graphs.then(function(values){
        var appCategories = [];
        var stackedSeries = [];
        stackedSeries.push({'name':'ETMCount', data: []}); 
        stackedSeries.push({'name':'CRCount', data: []}); 
        stackedSeries.push({'name':'SPCount', data: []}); 
        stackedSeries.push({'name':'DefectCount', data: []}); 
        var response =  fetchDavDataService.startService($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'sendGraphData',$scope.getDavParams('sendGraphData', '', ''));
        response.then(
      function(success) {
        $scope.strResponse = success.strResponse;
        console.log($scope.strResponse);
        var res = JSON.parse($scope.strResponse);
          $scope.title = res.notificationTitle;
          
        //Fix need to be applied below
         var deploydate = res[0].deployDate;
         angular.forEach(res,function(app) {
            appCategories.push(app.appName);
            angular.forEach(stackedSeries,function(svalue,skey){
            if(svalue.name == 'ETMCount'){
              svalue.data.push(parseInt(app.ETMCount));
            }
            if(svalue.name == 'CRCount'){
              svalue.data.push(parseInt(app.CRCount));
            }
            if(svalue.name == 'SPCount'){
              svalue.data.push(parseInt(app.SPCount));
            }
            if(svalue.name == 'DefectCount'){
              svalue.data.push(parseInt(app.DefectCount));
            }
        });
        });
        console.log(stackedSeries);
        var highchartSetup = {
          xAxis: {
            lineWidth: 1,
            lineColor: '#cecebf',
            categories: appCategories,
            title: {
              text:null
            }
          },
          yAxis: {
            labels:{
              enabled: true
            },
            lineWidth: 1,
            lineColor: '#cecebf',
            title: {
              text:'Count'
            }
          },
          chart: {
            spacingTop:40,
            type: 'column',
            color:'#ccc',
            height: 450
          },
          title: {
            text: "Deployment Date : "+ deploydate,
            style:{
                fontSize: '15'
            },
          },
          plotOptions: {
            series: {
              cursor: 'pointer'
            }
          },
          credits: {
            enabled: false
          },
          /*legend: {
            align: 'center',
            //verticalAlign: 'top',
            y:-110,
            x:0,
            border: false,
            borderWidth:0,
            floating: true,
            shadow: false,
            symbolPadding: 10,
            symbolWidth: 20,
            padding:40
          },*/
          series: stackedSeries,
          plotOptions: {
            column: {
              stacking: 'normal',
              showInLegend : true,
              dataLabels: {
                  enabled : false
              }
            }
          }
        };

        $('#graph' + value).highcharts(highchartSetup);
      },
      function(error) {
        alert("Got error while fetching the application updates.");
      }
    );
       
      });
    });
            
    }
        
    if($scope.tittle != '')
        {
            $scope.tittleflag = true;
        }
       //Changes from Abbas 
    $scope.update = function(value) {
    
    var response =  fetchDavDataService.startService($scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.loginData.username, $scope.appVersion,'setApprovalStatus',$scope.getDavParams('setApprovalStatus', value,($scope.crData['Deployment Start']).trim()));
        response.then(
      function(success) {
        $scope.strResponse = success.strResponse;
        var res = JSON.parse($scope.strResponse);
  
        if(res.result)
        	alert("Your Status has been updated");
        else
        	alert("Your Status was not updated. Please try again later.");
      },
      function(error) {
        alert("Got error while updating status.");
      }
    );
      
    };
        
    });
  })