angular.module('starter.controllers')
  .controller('headsUpCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate, $ionicModal,$ionicLoading,headsUpOngoingPromise,headsUpClosedPromise,headsUpHistoryPromise, headsUpDetailsByIdPromise,$state)  {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }
	   
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
	//$scope.imagesName = [];
    $scope.$on('$ionicView.enter', function(e) {
		$scope.$parent.$parent.inDetailpage = false;
	  $ionicLoading.show();
      $scope.$parent.$parent.shareOnAppPage = false;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';
	  
	  $scope.nextSlide = function() {
        $ionicSlideBoxDelegate.next();
      }
      $scope.previousSlide = function() {
        $ionicSlideBoxDelegate.previous();
      }
	  
      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
	  
	  $scope.$parent.$parent.currentTeamName = 'Heads Up';
	  $scope.ongoingLst =[];
	  $scope.closedLst =[];
	  $scope.historyLst =[];

    $scope.refreshHeadsup = function(){
	  var ongoing = headsUpOngoingPromise.ongoingDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');
            
           $scope.ongoingLst =[];
           ongoing.then(function(response1) {
		  	  
			 if(response1!= '')
			 { 
				angular.forEach(response1, function(data) {
				 var parsedData =JSON.parse(data);
				 $scope.ongoingLst.push(parsedData);
				  
			 });
			 }
			 else
			 {
				 $scope.openRecord= "No open heads up available";
			 }
          
				$ionicLoading.hide();
                $scope.$broadcast('scroll.refreshComplete');
		});
				
				
		   
	  var closedDtls = headsUpClosedPromise.closedDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');

          $scope.closedLst =[];
           closedDtls.then(function(response2) {
		  	if(response2!= '')
			 {    
           angular.forEach(response2, function(data) { 
		   		var parsedData =JSON.parse(data);
				$scope.closedLst.push(parsedData);
								 
			 });
			 }
			 else
			 {	
				$scope.closeRecord= "No closed heads up available";		
			 }
			    $ionicLoading.hide();
                $scope.$broadcast('scroll.refreshComplete');
               
			 });
			
			
			
		  
	  var historyDtls = headsUpHistoryPromise.historyDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');

          $scope.historyLst = [];
           historyDtls.then(function(response3) {
		   if(response3!= '')
		   {     
				angular.forEach(response3, function(data) { 	
				$scope.responseObj3 = true;
				var parsedData =JSON.parse(data);
				$scope.historyLst.push(parsedData);
								 
			 });
		   }
		   else
		   {
			   $scope.historyRecord= "No heads up available in history";	
		   }
			
				$ionicLoading.hide();
                $scope.$broadcast('scroll.refreshComplete');
		   });
        
               
      };
       
        if (Object.keys($scope.historyLst).length != 0) {
        //There is data already, so won't load again until user refreshes
        $ionicLoading.hide();
      }
      else {
        //There is no data, so it is the first time
        $scope.refreshHeadsup();
      }   

        
   
    });
  
  })
  
   .controller('headsUpDtlsCtrl', function($scope, $stateParams, $http, $ionicHistory, $ionicSlideBoxDelegate,$ionicLoading, $ionicModal, headsUpOngoingPromise,headsUpClosedPromise,headsUpHistoryPromise,headsUpUpdateHistoryPromise,headsUpDetailsByIdPromise, $state)  {
    $('#mainmenuid').show();
    $scope.refreshImages = function() {
      $state.reload();
    }	   
    $scope.images = [];
    $scope.heightLandscape = {};
    $scope.adjustHeigt = {};
    $scope.styleSlider = {};
	//$scope.imagesName = [];
    $scope.$on('$ionicView.enter', function(e) {
      $scope.$parent.$parent.inDetailpage = true;
	  $ionicLoading.show();
      $scope.$parent.$parent.shareOnAppPage = true;
      $scope.$parent.$parent.shareHeadsUp = true ;
      $scope.$parent.$parent.currentImageURL = $scope.images[0];
      $scope.enableOverflow = 'false';
	  
	  $scope.nextSlide = function() {
        $ionicSlideBoxDelegate.next();
      }
      $scope.previousSlide = function() {
        $ionicSlideBoxDelegate.previous();
      }
	  
      function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      $ionicModal.fromTemplateUrl('templates/image-modal.html', {
        scope: $scope,
        animation: 'slide-in-up'
      }).then(function(modal) {
        $scope.modal = modal;
      });

      $scope.openModal = function() {
        $scope.modal.show();
      };

      $scope.closeModal = function() {
        $scope.modal.hide();
      };

      //Cleanup the modal when we're done with it!
      $scope.$on('$destroy', function() {
        $scope.modal.remove();
      });
      // Execute action on hide modal
      $scope.$on('modal.hide', function() {
        // Execute action
      });
      // Execute action on remove modal
      $scope.$on('modal.removed', function() {
        // Execute action
      });
      $scope.$on('modal.shown', function() {
        console.log('Modal is shown!');
      });
      $scope.showImage = function(index) {
        // alert(index);
        $scope.imageSrc = index;
        // alert($scope.imageSrc);

        $scope.openModal();
      }
      
      $scope.slideHasChanged = function(index) {
        $scope.$parent.$parent.currentImageURL = $scope.images[index];
      }
      $scope.imagesResults = [];
      delete $scope.$parent.$parent.currentTeamName;
      delete $scope.$parent.$parent.currentApplication;
      delete $scope.$parent.$parent.currentStatus;
      
      var detailsById = headsUpDetailsByIdPromise.getDetailsById($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceInfo(), $scope.appVersion,'heads_up',$stateParams.id);
        
        detailsById.then(function(response) {
           var parsedData =JSON.parse(response);
            if($stateParams.type!="history")
            $stateParams.type=parsedData.status;

      $scope.myVar = 0;
	  if($stateParams.type=='open' || $stateParams.type=='in progress')
	  {
		  $scope.updateHist = [];
         
		   var ongoing = headsUpOngoingPromise.ongoingDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceInfo(), $scope.appVersion,'heads_up');

           ongoing.then(function(response) {
		  	   var updateHistoryDtls = headsUpUpdateHistoryPromise.updateHistoryDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,$stateParams.id);
					 
			updateHistoryDtls.then(function(hresponse) {
				
				angular.forEach(hresponse, function(histData) {
					var cparsedData =JSON.parse(histData);
				 $scope.updateHist.push(cparsedData);
										
				}); 
           angular.forEach(response, function(data) { 
				var parsedData =JSON.parse(data);
				 if($stateParams.id == parsedData.id)
				 {
                     $scope.$parent.$parent.currentApplication = parsedData.heading;
					 
					 $scope.id = $stateParams.id;
                     $scope.heading = parsedData.heading;
					 $scope.desc = parsedData.description;
					 $scope.attn = parsedData.attn;
					 $scope.internal = parsedData.internal;
					 $scope.external = parsedData.external;
					 $scope.escalatedTo = parsedData.escalatedTo;
					 $scope.createdBy = parsedData.createdBy;
                     $scope.createdDate = parsedData.createdDate;
                     
                   if($stateParams.type=='open')
                   {
                       $scope.status = "Open";
                       if($scope.updateHist.length>0)
                           {
                               $scope.myVar = 1;
                               $scope.updatedBy = parsedData.updatedBy;
                               $scope.updateDate = parsedData.updateDate;
                           }
                   }
                   
               else
                   {
                       $scope.myVar = 1;
                       $scope.status = "In progress";
                       $scope.updatedBy = parsedData.updatedBy;
                       $scope.updateDate = parsedData.updateDate;
                   }
				 }
               
               
                $scope.$parent.$parent.headsUpData = {
               
                'id': $stateParams.id,
                'Title': $scope.heading,
                'Description': $scope.desc,
                'Status':$scope.status,
                'Attn':  $scope.attn,
                'Internal': $scope.internal,
                'External': $scope.external,
                'Escalated To': $scope.escalatedTo,
                'History' : $scope.updateHist,
                'Created By': $scope.createdBy,
                'Created Date': $scope.createdDate,
                'Updated By': $scope.updatedBy,
                'Updated Date': $scope.updateDate,
               
              };
                $scope.$parent.$parent.headsupSubject = $scope.heading;
                   
				}); 		 
			 });
			$ionicLoading.hide();		
				
		   });
	  }
	  
	  else if($stateParams.type=='closed')
	  {
          $scope.myVar = 1;
		  $scope.updateHist = [];
		   var closedDtls = headsUpClosedPromise.closedDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');
		   
		   closedDtls.then(function(closedResponse) {
			   
		   var updateHistoryDtls = headsUpUpdateHistoryPromise.updateHistoryDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,$stateParams.id);
					 
			updateHistoryDtls.then(function(response) {
				
				angular.forEach(response, function(histData) {
					var parsedData =JSON.parse(histData);
				 $scope.updateHist.push(parsedData);
										
				});
						
				angular.forEach(closedResponse, function(closedData) { 
		   
		  
				var cParsedData =JSON.parse(closedData);
				 if($stateParams.id == cParsedData.id)
				 {
					 $scope.$parent.$parent.currentApplication = parsedData.heading;  
                     
					 $scope.id = $stateParams.id;
                     $scope.heading = parsedData.heading;
					 $scope.desc = cParsedData.description;
					 $scope.attn = cParsedData.attn;
					 $scope.internal = cParsedData.internal;
					 $scope.external = cParsedData.external;
					 $scope.escalatedTo = cParsedData.escalatedTo;
					 $scope.createdBy = parsedData.createdBy;
					 $scope.createdDate = parsedData.createdDate;
					 $scope.updatedBy = parsedData.updatedBy;
                     $scope.updateDate = parsedData.updateDate;
				 }
                    $scope.status ="Closed";
                    
                    
                 $scope.$parent.$parent.headsUpData = {
               
                'id': $stateParams.id,
                'Title': $scope.heading,
                'Description': $scope.desc,
                'Status':$scope.status,
                'Attn':  $scope.attn,
                'Internal': $scope.internal,
                'External': $scope.external,
                'Escalated To': $scope.escalatedTo,
                'History' : $scope.updateHist,
                'Created By': $scope.createdBy,
                'Created Date': $scope.createdDate,
                'Updated By': $scope.updatedBy,
                'Updated Date': $scope.updateDate,
               
              };
                            
                $scope.$parent.$parent.headsupSubject = $scope.heading;
				 		 
			 });
		 
					
				});
           
					
			$ionicLoading.hide();	
		   });		  
	  }
	  
	   else if($stateParams.type=='history')
	  {
          $scope.myVar = 1;
		  $scope.updateHist = [];
		   var historyDtls = headsUpHistoryPromise.historyDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,'heads_up');

           historyDtls.then(function(response) {
		  	 
			var updateHistoryDtls = headsUpUpdateHistoryPromise.updateHistoryDtls($scope.loginData.username,$scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion,$stateParams.id);
					 
			updateHistoryDtls.then(function(hresponse) {
				
				angular.forEach(hresponse, function(histData) {
					var cparsedData =JSON.parse(histData);
				 $scope.updateHist.push(cparsedData);
										
				});
				
           angular.forEach(response, function(data) { 
				var parsedData =JSON.parse(data);
				 if($stateParams.id == parsedData.id)
				 {
                     $scope.$parent.$parent.currentApplication = parsedData.heading;
					 
					 $scope.id = $stateParams.id;
                     $scope.heading = parsedData.heading;
					 $scope.desc = parsedData.description;
					 $scope.attn = parsedData.attn;
					 $scope.internal = parsedData.internal;
					 $scope.external = parsedData.external;
					 $scope.escalatedTo = parsedData.escalatedTo;
                     $scope.createdBy = parsedData.createdBy;
                     $scope.createdDate = parsedData.createdDate;
                     $scope.updatedBy = parsedData.updatedBy;
                     $scope.updateDate = parsedData.updateDate;
				 }
                     $scope.status = "Closed";
				 
                 $scope.$parent.$parent.headsUpData = {
               
                'id': $stateParams.id,
                'Title': $scope.heading,
                'Description': $scope.desc,
                'Status':$scope.status,
                'Attn':  $scope.attn,
                'Internal': $scope.internal,
                'External': $scope.external,
                'Escalated To': $scope.escalatedTo,
                'History' : $scope.updateHist,
                'Created By': $scope.createdBy,
                'Created Date': $scope.createdDate,
                'Updated By': $scope.updatedBy,
                'Updated Date': $scope.updateDate,
               
              };
                       
                $scope.$parent.$parent.headsupSubject = $scope.heading;
			 });
			 });		
			$ionicLoading.hide();	
		   });
	  }
	 });
	  
      $scope.$parent.$parent.currentTeamName = '';
   });
  
  })