angular.module('starter.controllers')
  .controller('impactViewCtrl', function($scope, $stateParams, $http,$location, $ionicHistory, impactPromise, $state,$ionicLoading, $ionicSlideBoxDelegate,$ionicPopup) {
			     
		$scope.refreshImpact = function() {
      $state.reload();
    }		
    
    
    $scope.$on('$ionicView.enter', function(e) {
    	
    	$ionicLoading.show();
    	
		function doOnOrientationChange() {
        switch (window.orientation) {
          case -90:
          case 90:
          if (ionic.Platform.isIOS()) {
          $('#mynetwork').css({'height':'350px'});
          $('#mynetwork').css({'width':'600px'});
        }
            $scope.heightLandscape = {
              height: '-webkit-fill-available',
              width: 'unset'
            };
            $scope.enableOverflow = 'true';
            $scope.adjustHeigt = {
              'padding-top': '16%'
            };
            break;
          default:
          if (ionic.Platform.isIOS()) {
          $('#mynetwork').css({'height':'500px'});
          $('#mynetwork').css({'width':'350px'});
        }
            $scope.heightLandscape = {};
            break;
        }
      }
      window.addEventListener('orientationchange', doOnOrientationChange);
      if (ionic.Platform.isIOS()) {
        $scope.styleSlider = {
          "margin-top": 23+'px',
          "margin-bottom": 50+'px'
        };
      }
      
        var line=$stateParams.lineName;
        
      	$('#mainmenuid').hide();
      	$scope.$parent.$parent.inDetailpage = true;
      	
    		delete $scope.$parent.$parent.currentTeamName; 
        $scope.$parent.$parent.currentTeamName = line;
        
		var network = null;
		var rootNode = null;
		  
    $scope.options = {
    	autoResize: true,
  		height: '100%',
  		width: '100%',
			interaction : {
				dragNodes : false,
				dragView : true,
				hover : false,
				hoverConnectedEdges : false,
				hideNodesOnDrag: false
			},
			layout : {
				randomSeed: 2,
				improvedLayout:true,
				hierarchical : {
					enabled : false
					}
			},
			nodes : {
				borderWidth: 0.5,
			    borderWidthSelected: 0.5,
				font : {
					color : 'white',
					size : 28, // px
					face : 'arial',
					background : 'none',
					strokeWidth : 0, // px
					strokeColor : '#ffffff',
					align : 'center',
					multi : false,
					vadjust : 0,
					bold: {
        color: 'white',
        size: 28, // px
        face: 'arial',
        vadjust: 0,
        mod: 'bold'
      }
				},
				color : {
					border : 'white',
					background : '#008000',
					highlight : {
						border : '#00b300',
						background : '#00b300'
					},
					hover : {
						border : 'black',
						background : 'white'
					}
				},
				shape : 'box',
				shapeProperties : {
					  borderDashes: false, // only for borders
				      borderRadius: 2,     // only for box shape
				      interpolation: false,  // only for image and circularImage shapes
				      useImageSize: false,  // only for image and circularImage shapes
				      useBorderWithImage: false  
				},
				
				heightConstraint: { 
					minimum: 16, 
					valign: 'middle' }
			},
			edges : {
				arrows : {
					to : {
						enabled : true,
						scaleFactor : 1,
						type : 'arrow'
					},
				},
				color: {
				      color:'black',
				      highlight:'#black',
				      hover: '#black',
				      inherit: 'from',
				      opacity: 0.5
				    },
				    smooth: {
				        enabled: false,
				        type: "dynamic",
				        roundness: 0.2
				      }
			},
			physics:{
    		enabled: true,
		    		barnesHut: {
		      gravitationalConstant: -2000,
		      centralGravity: 0.3,
		      springLength: 95,
		      springConstant: 0.04,
		      damping: 0.09,
		      avoidOverlap: 0
		    	},
    		forceAtlas2Based: {
        	gravitationalConstant: -500,
        	centralGravity: 0.04,
        	springConstant: 0.08,
        	springLength: 200,
        	damping: 0.9,
        	avoidOverlap: 1
      	},
	    stabilization: {
	        enabled: true,
	        iterations: 1000,
	        updateInterval: 100,
	        onlyDynamicEdges: false,
	        fit: true
	      },
	    solver: 'forceAtlas2Based'
  }
			
		};
		
		$scope.makeNewNetwork = function (mainNode, node, edge){
			
			var newEdges = [];
			var newNodes = [];
			var x ;
			
			rootNode=mainNode;
			
			edge.forEach(function(data)
			{
  				if(data.from == mainNode || data.to ==mainNode){
  					newEdges.push(data) ;
  					}
			});
			
			
			node.forEach(function(data)
			{
				x =true;
  				if(data.id == mainNode){
  					newNodes.push(data) ;
  				}
  				else{
  					newEdges.forEach(function(data1)
  					{
  						if(data.id == data1.to || (data.id == data1.from && data1.to == mainNode) ){
  							
  							if(x==true){
  								newNodes.push(data);
									x=false;
  							}
  						}
  						
  					});
  				}
			});
			
			$scope.networkData(newNodes, newEdges);
			
			}
		
		
		$scope.networkData = function (node, edge){

		
			var container = document.getElementById('mynetwork');
			
			// data in the vis format
			var data = {
				nodes : node,
				edges : edge
			};
			
			
							
			// initializing network!
			 network = new vis.Network(container, data, $scope.options);
			  network.on("stabilizationProgress", function(params) {
               $ionicLoading.show();
            });
            network.once("stabilizationIterationsDone", function() {
               $ionicLoading.hide(); 
            });
			 
			
			network.on("selectNode", function (params) {
															
                             params.event = "[original event]";
                             var mainNode = this.getNodeAt(params.pointer.DOM);
                                 if(rootNode != mainNode) {  
                                 	rootNode=null;   
                                 	                   
                           				$scope.makeNewNetwork(mainNode, $scope.nodes, $scope.edges);
                         						}
                         	 		else{
                         	 			
                         	 			var check = false;
                         	 			angular.forEach($scope.$parent.$parent.resultData['amoc']['ongoing'], function(wholeList) {
														        if (wholeList.name.toLowerCase() == mainNode.toLowerCase()) {
														          check = true;
														        }
														      });
                         	 			
                         	 			
                         	 			if(check){
																		  $state.go("app.application",{'teamname':'amoc','application':mainNode, 'current':'ongoing'});
																}
																else{
																	//alert('No alerts ongoing now');
																	$scope.showAlert(mainNode);
																}
																		
                         				}
                            
                         });
                         
													
						         $scope.showAlert = function(mainNode) {
										     var alertPopup = $ionicPopup.alert({
										       title: 'No ongoing alerts in '+ mainNode
										     });
										     
										   };  
										              
						       //for re-centring network                  
						      network.on("doubleClick", function (params) {
						                                  params.event = "[original event]";
						                                  var options = {offset: {x:0,y:0},
						                                	      duration: 1000,
						                                	      easingFunction: 'linear'
						                                	    };
						                                	    network.fit({animation:options});
						                                });
                         
		}
		
		if(line == 'Uverse')
		{
											var nodes = new vis.DataSet([
                             {id: 'LS OMS', label: 'LS OMS', widthConstraint : { minimum: 1000}, heightConstraint : { minimum: 50, valign: 'middle' }, x: -50, y: -600 },
                             {id: 'CSI', label: 'CSI', x: -850, y: -100, shape: 'circle'},
                             {id: 'CVOIP OMC-P', label: 'CVOIP OMC-P', x: 400, y: 100},
                             {id: 'BBNMS LS', label: 'BBNMS LS',  widthConstraint : { minimum: 500}, heightConstraint : { minimum: 50, valign: 'middle' },  x: -100, y: -150},
                             {id: 'Lightspeed Enabler', label: 'Lightspeed Enabler', x: 750, y: -300},
                             {id: 'FORCE', label: 'FORCE',   x: -450, y: 280},
                             {id: 'Legacy Services', label: 'Legacy Services',  x: -1050, y: 100},
                             {id: 'AMNQ', label: 'AMNQ', x: -750, y: 100},
                             {id: 'OVALS', label: 'OVALS', x: -900, y: 100},
                             {id: 'LFACS', label: 'LFACS', x: -300, y: 100},
                             {id: 'ERP-EPIC', label: 'ERP-EPIC',   x: 800, y: -100},
                             {id: 'Oracle', label: 'Oracle',  x: 800, y: 100},
                             {id: 'EDGE', label: 'EDGE',  x: -450, y: 100},
                             {id: 'EDP', label: 'EDP',  x: -550, y: -200},
                             {id: 'DSCAT', label: 'DSCAT',  x: 250, y: -100},
                             {id: 'FIRST', label: 'FIRST', x: 400, y: -100},
                             {id: 'IOMIP', label: 'IOMIP',  x: 600, y: -100},
                             {id: 'ORA,LIDB/AS ', label: 'ORA,LIDB/AS ', x: 600, y: 100},
                             {id: 'SOEG', label: 'SOEG',  x: 250, y: 100},
                             {id: 'G2', label: 'G2',  x: -250, y: -320},
                             {id: 'LS AMSS', label: 'LS AMSS',  x: -140, y: -300},
                             {id: 'SAM', label: 'SAM',  x: 30, y: -280},
                             {id: 'CMS EMS', label: 'CMS EMS', x: 20, y: 100},
                             {id: 'GCAS Web', label: 'GCAS Web',x: -450, y: 420},
                             {id: 'LNP SOA', label: 'LNP SOA',  x: -340, y: -280},
                             {id: 'SDP', label: 'SDP', x: -150, y: 100 },
                             {id: 'uDAS', label: 'uDAS', x: -50, y: 300},
                             {id: 'MPSYS', label: 'MPSYS', x: -200, y: 300},
                             {id: 'SPP', label: 'SPP', x: -340, y: 300}, 
                             {id: 'IPTV', label: 'IPTV', x: -50, y: 420},
                             {id: 'Equifax (Interconnect)', label: 'Equifax (Interconnect)', x: -600, y: 180},
                             {id: 'LS CRM', label: 'LS CRM', widthConstraint : { minimum: 200}, heightConstraint : { minimum: 50, valign: 'middle' }, x: -850, y: -500},
                             {id: 'LSRV', label: 'LSRV', x: 120, y: 100},
                             {id: 'External Telcos', label: 'External Telcos',  x: 120, y: 300},
                             {id: 'Others', label: 'Others',widthConstraint : { minimum: 250}, heightConstraint : { minimum: 80, valign: 'middle' }, x: 400, y: 300}
                         ]);

                         // create an array with edges
                 var edges = new vis.DataSet([
                            {from: 'LS OMS', to: 'CSI'}, 
                            {from: 'CSI', to: 'LS OMS'},
                            {from: 'LS CRM', to: 'CSI'},
                             {from: 'CSI', to: 'Legacy Services'},
                             {from: 'CSI', to: 'AMNQ'},
                             {from: 'CSI', to: 'OVALS'},
                             {from: 'CSI', to: 'LFACS'},
                             {from: 'CSI', to: 'CAS'},
                             {from: 'LS OMS', to: 'Lightspeed Enabler'},
                             {from: 'LS OMS', to: 'DSCAT'},
                             {from: 'LS OMS', to: 'EDP'},
                             {from: 'LS OMS', to: 'ERP-EPIC'},
                             {from: 'ERP-EPIC', to: 'Oracle'},
                             {from: 'EDP', to: ''},
                             {from: 'DSCAT', to: ''},
                             {from: 'CSI', to: 'EDGE'},
                             {from: 'EDGE', to: 'FORCE'},
                             {from: 'LS OMS', to: 'FIRST'},
                             {from: 'FIRST', to: 'CVOIP OMC-P'},
                             {from: 'LS OMS', to: 'IOMIP'},
                             {from: 'IOMIP', to: 'ORA,LIDB/AS '},
                             {from: 'LS OMS', to: 'BBNMS LS'},
                             {from: 'BBNMS LS', to: 'LFACS'},
                             {from: 'BBNMS LS', to: 'EDGE'},
                             {from: 'BBNMS LS', to: 'SOEG'},
                             {from: 'BBNMS LS', to: 'LSRV'},
                             {from: 'BBNMS LS', to: 'G2'},
                             {from: 'BBNMS LS', to: 'LS AMSS'},
                             {from: 'BBNMS LS', to: 'SAM'},
                             {from: 'BBNMS LS', to: 'CMS EMS'},
                             {from: 'CMS EMS', to: 'RG'},
                             {from: 'FORCE', to: 'GCAS Web'},
                             {from: 'BBNMS LS', to: 'LNP SOA'},
                             {from: 'BBNMS LS', to: 'SDP'},
                             {from: 'SDP', to: 'uDAS'},
                             {from: 'SDP', to: 'MPSYS'},
                             {from: 'SDP', to: 'SPP'},
                             {from: 'uDAS', to: 'IPTV'},
                             {from: 'LSRV', to: 'External Telcos'},
                             {from: 'CSI', to: 'Equifax (Interconnect)'}
                             
                         ]);

                         // create a network
                         var container = document.getElementById('mynetwork');
                         

                         var options = {
                 		    	autoResize: true,
                 		  		height: '100%',
                 		  		width: '100%',
                 					interaction : {
                 						dragNodes : false,
                 						dragView : true,
                 						hover : false,
                 						hoverConnectedEdges : false,
                 						hideNodesOnDrag: false
                 					},
                 					layout : {
                 						randomSeed: 1200,
                 						improvedLayout:true,
                 						hierarchical : {
                 							enabled : false,
                 						      levelSeparation: 250,
                 						      nodeSpacing: 100,
                 						      treeSpacing: 800,
                 						      blockShifting: false,
                 						      edgeMinimization: false,
                 						      parentCentralization: false,
                 						      direction: 'UD',        // UD, DU, LR, RL
                 						      sortMethod: 'hubsize'   // hubsize, directed
                 							}
                 					},
                 					nodes : {
                 						borderWidth: 0.5,
                 					    borderWidthSelected: 0.5,
                 						font : {
                 							color : 'white',
                 							size : 30, // px
                 							face : 'arial',
                 							background : 'none',
                 							strokeWidth : 0, // px
                 							strokeColor : '#ffffff',
                 							align : 'center',
                 							multi : false,
                 							vadjust : 0,
                 							bold: {
                 		        color: 'white',
                 		        size: 50, // px
                 		        face: 'arial',
                 		        vadjust: 0,
                 		        mod: 'bold'
                 		      }
                 						},
                 						color : {
                 							border : 'white',
                 							background : '#008000',
                 							highlight : {
                 								border : '#00b300',
                 								background : '#00b300'
                 							},
                 							hover : {
                 								border : 'black',
                 								background : 'white'
                 							}
                 						},
                 						shape : 'box',
                 						shapeProperties : {
                 							  borderDashes: false, // only for borders
                 						      borderRadius: 2,     // only for box shape
                 						      interpolation: false,  // only for image and circularImage shapes
                 						      useImageSize: false,  // only for image and circularImage shapes
                 						      useBorderWithImage: false  
                 						},
                 						
                 						heightConstraint: { 
                 							minimum: 16, 
                 							valign: 'middle' }
                 					},
                 					edges : {
                 						arrows : {
                 							to : {
                 								enabled : true,
                 								scaleFactor : 1,
                 								type : 'arrow'
                 							},
                 						},
                 						color: {
                 						      color:'black',
                 						      highlight:'#black',
                 						      hover: '#black',
                 						      inherit: 'from',
                 						      opacity: 0.5
                 						    },
                 						    smooth: {
                 						        enabled: true,
                 						        type: "discrete",
                 						        roundness: 0
                 						      }
                 					},
                 					physics:{
                 					    enabled: false,
                 					    hierarchicalRepulsion: {
                 					      centralGravity: 0.0,
                 					      springLength: 100,
                 					      springConstant: 0.01,
                 					      nodeDistance: 200,
                 					      damping: 0.09
                 					    },
                 					    maxVelocity: 50,
                 					    minVelocity: 0.1,
                 					    solver: 'hierarchicalRepulsion'
                 					    
                 					  }
                 					
                 				};
                         var impactsPromise = impactPromise.startService(line ,$scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
                         
                         impactsPromise.then(function(response) {
																if (response) {
																	$scope.no = response.impactApplicationNodes;
																	$scope.ed = response.impactApplicationEdges;
																	
												 var newNodes=[];
                         var alertNode=[];
                         
                         angular.forEach($scope.no, function(value, key){
					      
												      if(value.color == 'red'){
												    	  value.color = {background:'#ff1a1a',highlight:{border:'#ff1a1a',background:'#ff1a1a'}};
												    	  alertNode.push(value);
												    	}
												      else if(value.color == 'yellow'){
												    	  value.color = {background:'#ffd11a',highlight:{border:'#ffd11a',background:'#ffd11a'}};
												    	  alertNode.push(value);
												    	}
												    	else if(value.color == 'orange'){
												    	  value.color = {background:'#ff8c1a',highlight:{border:'#ff8c1a',background:'#ff8c1a'}};
												    	  alertNode.push(value);
												    	}												    	
															else
																value.color = {background:'#00b300'};
												    
												   });
												   
												   
                         angular.forEach(nodes, function(data){
             				
			             				data.label = data.label.split(' ').join(' \n ');
			             				
						             				angular.forEach(alertNode, function(data1){
			             				
									             				if(data.id==data1.id){
									             					//adding color
									             					data.color = data1.color;
									             				}
									             	
						             			   });
			             			
			             			    	  newNodes.push(data);
             			    	
             			   });
						
                         newEdges=[];
                         
                         var data = {
                                 nodes: newNodes,
                                 edges: edges
                             };
                             
                         $ionicLoading.hide();
                         
                         var network = new vis.Network(container, data, options);
                         
                         network.on("doubleClick", function (params) {
                                  params.event = "[original event]";
                                  var options = {offset: {x:0,y:0},
                                	      duration: 1000,
                                	      easingFunction: 'linear'
                                	    };
                                	    network.fit({animation:options});
                                });
                                
                                
                                
                         network.on("selectNode", function (params) {
                             params.event = "[original event]";
                             var mNode=this.getNodeAt(params.pointer.DOM);
                             if(mNode == 'Others'){
                             	
                             	var otherNodes=[];
                             	var otherEdges=[];
                             	
                             	otherNodes.push({id: 'Others', label: 'Others',widthConstraint : { minimum: 250}, heightConstraint : { minimum: 80, valign: 'middle' }, x: 400, y: 300});
                             	
                             	angular.forEach(alertNode, function(data){
                             		var x=false;
                             		var y =data;;
					      
												      angular.forEach(newNodes, function(data1){
												      	 	
												      	 	if(data1.id == data.id){
														      	x=true;
														      }
														   });
														   
														   if(!x){
														   	otherNodes.push(y);
														   	otherEdges.push({from: 'Others', to: y.id });
														   }
												    
												  				});
												  			
												  				 if( otherNodes.length > 0)
												  				{
												  					data = {
		                                 nodes: otherNodes,
		                                 edges: otherEdges
                             				};
												  				
												  				network = new vis.Network(container, data, $scope.options);	
												  				
												  network.on("selectNode", function (params) {
															
                             params.event = "[original event]";
                             var mainNode = this.getNodeAt(params.pointer.DOM);
                                var check = false;
                         	 			angular.forEach($scope.$parent.$parent.resultData['amoc']['ongoing'], function(wholeList) {
														        if (wholeList.name.toLowerCase() == mainNode.toLowerCase()) {
														          check = true;
														        }
														      });
                         	 			
                         	 			if(check){
																		  $state.go("app.application",{'teamname':'amoc','application':mainNode, 'current':'ongoing'});
																}
																else{
																	$ionicPopup.alert({
																		       title: 'No Other Impacts '
																		     });
																}
															
                            
                         });
												  			
												  				}else
												  					{
												  						$ionicPopup.alert({
																		       title: 'No Impacts '
																		     });
												  					} 
												  				
                             	
                             	}
                             else{
                             	
                             	var check = false;
                         	 			angular.forEach($scope.$parent.$parent.resultData['amoc']['ongoing'], function(wholeList) {
														        if (wholeList.name.toLowerCase() == mNode.toLowerCase()) {
														          check = true;
														        }
														      });
                         	 			if(check){
																		  $state.go("app.application",{'teamname':'amoc','application':mNode, 'current':'ongoing'});
																}
																else{
																	//alert('No alerts ongoing now');
																	$ionicPopup.alert({
																		       title: 'No ongoing alerts in '+ mNode
																		     });
																}
																
																}
																
                         });
																}
																	else {
																	console.log('error');
																	}
																});
												                         
                         
		}
 		else{
 			var impactsPromise = impactPromise.startService(line ,$scope.loginData.username, $scope.getTimeFormat(), $scope.myDeviceFullInfo, $scope.appVersion);
    
    impactsPromise.then(function(response) {
				if (response) {

					
					$scope.nodes = response.impactApplicationNodes;
					$scope.edges = response.impactApplicationEdges;
					
					var newNode=[];
					var newEdge=[];
								

					 angular.forEach($scope.nodes, function(value, key){
					 			
					 			value.label = value.label.split(' ').join(' \n ');
					      
					      if(value.color == 'red')
					    	  value.color = {background:'#FF4646',highlight:{border:'#FF4646',background:'#FF4646'}};
					      else if(value.color == 'yellow')
					    	  value.color = {background:'#ffd11a',highlight:{border:'#ffd11a',background:'#ffd11a'}};
					    	else if(value.color == 'orange')
					    	  value.color = {background:'#ff8c1a',highlight:{border:'#ff8c1a',background:'#ff8c1a'}};
								else
									value.color = {background:'#00b300'};
					    
					   });
					   
					   var m;
					   angular.forEach($scope.nodes, function(value, key){
			      				if(value.cid > 10 || value.color.background != '#00b300')
			      				{
			      					if(value.cid<25){
								    		  m=value.cid*1.9;
								    		  s=30;
								    	  }
								    	else{ 
								    			m=value.cid*1.5;
								    			s=50;
								    			}
			    	  
				    	  value.heightConstraint={ minimum: m, valign: 'middle' };
				    	  value.widthConstraint = { minimum: m};
				    	  value.nodes = { font : {size : s } };
				    	  newNode.push(value);
			      				}
			    	  			
			   				});
					   
				$scope.networkData(newNode,newEdge);
					
					
				} else {
					console.log('error');
				}
			
 		});
 			
 		}
    
 
 
	});
	
	
});